// -*- coding:euc-jp -*-
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <regex.h>
#include <ddk/imm.h>
#include <stdbool.h>
#include "so/wimeapi.h"
#include "io/wimeio.h"
#include "lib/ut.h"
#include "canna.h"
#include "apisup.h"
#include "lib/list.h"
#include "lib/log.h"
#include "lib/version.h"
#if defined(__FreeBSD__)
#include "lib/freebsd.h"
#endif

bool wm_ime_composition(CannaContext_t* cx,char mj,int clstart);
extern Array InputWins;

/*
  return: true= false=Ǥ
*/
bool flush_msg_loop()
{
    MSG msg;
    bool st = true;
    while(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
	if(GetMessage(&msg,NULL,0,0) <= 0){
	    st = false;
	    break;
	}
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }
    return st;
}

/*01 
׵ѥå(Type 0)
	i32	Initialize MSBfirst
	i32	ǡĹ MSBfirst
	s8	Сֹ '᥸㡼ֹ桥ޥʡֹ:'
	s8	桼̾
ѥå(Type 0)
	u16	ХޥʡС MSBfirst
	i16	ƥֹ MSBfirst
饤ȤΥץȥ᥸㡼ֹ椬ФΤ礭ʤɤΥ顼ˤϡ
	i32	顼 MSBfirst
		顼: 1/Сߥޥå:RETURN_VERSION_ERROR_STAT
ʸ塤ΥǡΥХȥMSBfirst ǹԤʤФʤʤ

Initializeեɤˤbe1äƤ롣ΤޤCannaHeaderˤmajor=0,minor=0,length=1Ȥʤ롣
줬ƤФ줿Ǥinitializeեɤɤ߹Ǥʤ
s8ϣĤʸ̡ˤ褦ʵҤºݤϣĤʸ󡣰Ĥs8Ȥ"᥸㡼.ޥʡ:桼̾"Ȥʸ롣
 */
bool Init(CanHeader* ch,int fd)
{
    int32_t len;
    union{
	uint16_t res[2];
	uint32_t res32;
    } res;

    ImRead(&len,4);
    len = Swap4(len);
    char data[len];
    ImRead(data,len);
    DEBUGLOG(CH_CANNA,"header %4D, data '%s', fd %d\n",ch,data,fd);

    if(FindClient(fd) != NULL){
	//ʣν
	res.res[0] = res.res[1] = -1;
    }else{
	int client_major,client_minor;
	int n = sscanf(data,"%d.%d",&client_major,&client_minor);
	char* user = strchr(data,':');
	if(user != NULL)
	    ++user;
	if(n!=2 || client_major>WIME_CANNA_MAJOR || user==NULL){
	    /* 줿ǡ
	       ᥸㡼С󤬤ʤȤRETURN_VERSION_ERROR_STAT֤ȤˤʤäƤ뤬ϤʥIRproto.hˤꡢlibcannaˤϴޤޤƤʤΤˤʥäƤΤݤʤΤǡإåե˽񤤤Ƥ
	       ޥʡСϤȤꤢ̵뤹롣
	       桼̾ʤΤ̤Υ顼ˤ٤ݤʤΤǡ
	    */
	    res.res32 = Swap4(RETURN_VERSION_ERROR_STAT);
	    FATALLOG(CH_CANNA,"illegal data\n");
	}else{
	    res.res[0] = Swap2(WIME_CANNA_MINOR);
	    res.res[1] = Swap2(OpenConnection(fd,user));
	    DEBUGLOG(CH_CANNA,"context %hd, fd %d, user '%s'\n",Swap2(res.res[1]),fd,user);
	}
    }
    return ImWrite(&res,4);
}

/*02 λ
׵ѥå(Type 1)
ѥå(Type 2)
	i8	λ	: 0 / 顼: 1
 */
bool Finalize(CanHeader* ch,int fd)
{
    char st = (CloseConnection(fd) ? 0:-1);
    DEBUGLOG(CH_CANNA,"fd %d, status %hhd\n",fd,st);
    return Reply2(ch->Major,ch->Minor,st);
}

/*03 ƥȺ
  ׵ѥå(Type 1)
  ѥå(Type 5)
	i16	ƥֹ 顼: 1

ƥֹϣϢ֤Ȥϸ¤ʤ
 */
bool CreateContext(CanHeader* ch,int fd)
{
    int16_t cxn;
    if(OpenCannaContext(fd,&cxn) == NULL)
	cxn = -1;
    DEBUGLOG(CH_CANNA,"context %hd, fd %d\n",cxn,fd);
    return Reply5(ch->Major,ch->Minor,cxn);
}

/*04 ƥʣ:ꤵ줿ѴƥȤʣѴƥȤɽƥֹ֤
  ׵ѥå(Type 2)
	i16	ƥֹ
  ѥå(Type 5)
	i16	ƥֹ 顼: 1
 */
bool DupContext(CanHeader* ch,int fd)
{
    int16_t dstn=-1;
    int16_t srcn = Req2(ch);
    DEBUGLOG(CH_CANNA,"context %hd, fd %d\n",srcn,fd);
    if(ValidContext(srcn,__FUNCTION__) != NULL){
	DupWinParam params;
	CannaContext_t* cxd = OpenCannaContext(fd,&dstn);
	CannaContext_t* cxs = ValidContext(srcn,__FUNCTION__); //cxdäǲƥɥ쥹
	SetWinParam(cxd->Win,GetWinParam(cxs->Win,&params));
	ArCopy(&cxd->Dics,&cxs->Dics);
	ArCopy(&cxd->DicMode,&cxs->DicMode);
	
	DEBUGLOG(CH_CANNA,"%hd --> %hd\n",srcn,dstn);
    }
    return Reply5(ch->Major,ch->Minor,dstn);
}

/*05 ƥȺ
  ׵ѥå(Type 2)
	i16	ƥֹ
  ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
 */
bool CloseContext(CanHeader* ch,int fd UNUSED)
{
    char st=-1;
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx != NULL){
	CloseCannaContext(cx);
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*???
  06 GetDictionaryList	ơ֥ϿƤ뼭ΰ
  07 GetDirectoryList	ǥ쥯ȥˤ뼭ΰ
  0b GetMountDicList	ơ֥ϿƤ뼭ꥹ
  060bƱʤ졩
  atok
  06 Ѥ褦ꤷƤ뼭ΰ(ǥեȤμ񥻥å)
  07 Ѳǽʼΰ
  0b ޥȤƤ뼭ΰ
  ȤƤߤ롣
  imm-api˼ϢΤΤϤʤΤǡؤδؿϤɤ褦ʤ
*/
/*06 ơ֥ [atok]
ơ֥(ꥹ(ޥȥꥹ)Ͽǽʼ)ϿƤ뼭롥
׵ѥå(Type 3)
	i16	ƥֹ
	u16	̾ꥹȤΥХåե
ѥå(Type 6)
	i16	  顼: 1
	s8	̾ꥹ '̾@...@̾@@'
 */
bool GetDicList(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t bufsize;
    Req3(ch,&cxn,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, bufsize %hd\n",cxn,bufsize);
    DEBUGLOG(CH_CANNA,"*** NOT IMPLIMENT *** I DO NOTHING ***\n");
    return Reply6(ch->Major,ch->Minor,0,NULL,0); //ꥹȤʤｪλ
}

/*07 ǥ쥯ȥ [atok]
ǥ쥯ȥ(ơ֥(dics.dir)äǥ쥯ȥ)ˤ뼭ΰ롥
׵ѥå(Type 3)
	i16	ƥֹ
	u16	Хåե
ѥå(Type 6)
	i16	  顼: 1
	s8	ǥ쥯ȥ̾ꥹ  '̾@...@ ̾@@'
 */
bool GetDirList(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t bufsize;
    Req3(ch,&cxn,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, bufsize %hd\n",cxn,bufsize);
    DEBUGLOG(CH_CANNA,"*** NOT IMPLIMENT *** I DO NOTHING ***\n");
    return Reply6(ch->Major,ch->Minor,0,NULL,0);
}

/*08 ꥹɲ  ꤵ줿򤫤ʴѴѤ褦ˤ롣
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 /  顼: 1
̾Ͽ
 */
bool MountDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char st=-1;

    char* name = Req15(ch,&mode,&cxn);
    DEBUGDO(CH_CANNA,{MESG("mode 0x%x, context %hd, dic-name '%s'\n",mode,cxn,name);
	    MESG("*** I DO NOTHING ***\n");});
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx!=NULL){
	if(cx->Dics.use > 0)
	    -- cx->Dics.use; //ꥹȤνλޡȤ
	ArAddN(&cx->Dics,name,strlen(name)+1);
	ArAddChar(&cx->Dics,0);
	ArAdd1(&cx->DicMode,&mode);
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*09 ꥹȺ:ꤵ줿񤬤ʴѴѤʤ褦ˤ롣
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
̾
 */
bool UnmountDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char st=-1;
    Array dicname;

    ArNew(&dicname,1,NULL);
    ArPrint(&dicname,"%s",Req15(ch,&mode,&cxn));
    DEBUGDO(CH_CANNA,{MESG("mode 0x%x, context %hd, dic-name '%s'\n",mode,cxn,(char*)ArAdr(&dicname));
	    MESG("*** I DO NOTHING ***\n");});
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx!=NULL){
	int dn = ListFind(&cx->Dics,&dicname);
	if(dn  > 0){
	    ListRemove(&cx->Dics,dn);
	    ArRemove(&cx->DicMode,dn,1);
	    st = 0;
	}else
	    INFOLOG(CH_CANNA,"not found dictionary '%s'\n",(char*)ArAdr(&dicname));
    }
    ArDelete(&dicname);
    return Reply2(ch->Major,ch->Minor,st);
}

/*0a ꥹѹ:ѼμꥹȤν֤ѹ롥
׵ѥå(Type 15)
	i32	ͥ
	i16	ƥֹ
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
???  ͤͥ٤Ȥ뤬ϤɤͤʤΤ
  褯狼ʤΤǡꤵ줿ꥹȤƬ˻äƤ롣
 */
bool RemountDic(CanHeader* ch,int fd UNUSED)
{
    int32_t pr;
    int16_t cxn;
    char st=-1;
    Array dicname;

    ArNew(&dicname,1,NULL);
    ArPrint(&dicname,"%s",Req15(ch,&pr,&cxn));
    DEBUGDO(CH_CANNA,{MESG("context %hd, priority %d, dic-name '%s'\n",cxn,pr,(char*)ArAdr(&dicname));
	    MESG("*** I DO NOTHING ***\n");});
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx!=NULL){
	int dn = ListFind(&cx->Dics,&dicname);
	if(dn >= 0){
	    int mode = *(int32_t*)ArElem(&cx->DicMode,dn);
	    ArInsert(ArRemove(&cx->DicMode,dn,1),0,1,&mode);
	    ListRemove(&cx->Dics,dn);
	    ListInsert(&cx->Dics,0,&dicname);
	    st = 0;
	}else
	    INFOLOG(CH_CANNA,"not mount dictionary\n");
    }
    ArDelete(&dicname);
    return Reply2(ch->Major,ch->Minor,st);
}

/*0b ꥹȰ:ơ֥ϿƤ뼭ꥹ
׵ѥå(Type 3)
	i16	ƥֹ
	u16	̾ꥹȤΥХåե
ѥå(Type 6)
	i16	  顼: 1
	s8	̾ꥹ  '̾@...@ ̾@@'
*/
bool MountDicList(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t bufsize;
    int n=-1,len=0;
    char* p = NULL;

    Req3(ch,&cxn,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, buffer size %hd\n",cxn,bufsize);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx!=NULL && (len = ArUsing(&cx->Dics))<=bufsize){
	p = ArAdr(&cx->Dics);
	n = ListCount(&cx->Dics);
    }
    return Reply6(ch->Major,ch->Minor,n,p,len);
}

/*0c Ͽǽ䤤碌:ꤷξ
׵ѥå(Type 19)
	i32	⡼(0)
	i16	ƥֹ
	s8	桼̾  '桼̾@'
	s8	̾  '̾@'
ѥå(Type 10)
	i8	λ  : 0 / 顼: 1
	s8	̾ '̾@'
	s8	ե̾ 'ե̾@'
	i32[]	  ???28Х?(struct DicInfo28ХȤ餷)
*/
bool QueryDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* user;
    char* dic = Req19(ch,&mode,&cxn,&user);
    DEBUGLOG(CH_CANNA,"context %hd, mode 0x%x, user '%s', dic '%s'\n",cxn,mode,user,dic);	
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    return Reply2(ch->Major,ch->Minor,-1);
}

/*
  ʤʻ쥳("#"ϤĤʤ)winοͥɤˤ
  ʻơ֥뤬ʤȤ0
  ??? IME_REGWORD_STYLE_USER_FIRSTImmRegisterWordǻȤȥ顼ˤʤä
  IME_REGWORD_STYLE_USER_FIRST+1ʹߤμ¤ˤȤƤΤ
  ΤȤǤϡʻбե뤬ʤХ顼ˤƤ
*/
int canna_hinshi_to_win(const char* can_code)
{
    HinshiCor* hc;
    regex_t reg;

    if((hc=WimeData.HinshiTab) == NULL){
	ERRORLOG(CH_GLOBAL,"not found hinshi table\n");
	return 0;
    }
    for(; hc->Ccode!=NULL; ++hc){
	if(regcomp(&reg,hc->Ccode,REG_EXTENDED)==0){
	    regmatch_t m;
	    if(regexec(&reg,can_code,1,&m,0)==0)
		break;
	    regfree(&reg);
	}
    }
    if(hc->Ccode != NULL)
	regfree(&reg);
    else{
	ERRORLOG(CH_GLOBAL,"unknown part code:%s\n",can_code);
	hc=WimeData.HinshiTab; //Ƭˤ륳ɤ֤
    }
    return hc->Wcode;
}

/*
  ñ'ɤ ʻ쥳 Ͽʸ'
  ??? ڤϥڡ ϿʸϣĤȤƤΤ
 */
bool reg_or_unreg_word(CanHeader* ch,BOOL WINAPI (*proc)(HKL,LPCWSTR, DWORD, LPCWSTR))
{
    int16_t cxn;
    uint16_t* wordrec;
    bool st=true;
    
    char* dicname = Req12((Req12_t*)ch,&cxn,&wordrec);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    FromClientToU16(cx,wordrec);
    DEBUGLOG(CH_CANNA,"context %hd, wordinfo '%W', dic-name '%s'\n",cxn,wordrec,dicname);

    uint16_t* yomi = U16Tok(&wordrec);
    char* hinshi = U16ToEj(NULL,NULL,U16Tok(&wordrec),-1); //ʻ쥳ʸ
    int sty = canna_hinshi_to_win(hinshi+1);
    if(sty == 0){ //ʻơ֥뤬ʤ
	ERRORLOG(CH_CANNA,"not exist hinshi table\n");
	st = false;
    }else{
	uint16_t* word = U16Tok(&wordrec); //Ͽ
	DEBUGLOG(CH_CANNA,"reading [%W], style 0x%x, word [%W]\n",yomi,sty,word);
	if(!proc(GetKeyboardLayout(0),(LPCWSTR)yomi,sty,(LPCWSTR)word)){
	    ERRORLOG(CH_CANNA,"fail Imm(Un)RegisterWordW\n");
	    st = false;
	}
    }
    free(hinshi);
    return Reply2(ch->Major,ch->Minor,(st?0:-1));
}

/*0d ñϿ:˿ñϿ
׵ѥå(Type 12)
	i16	ƥֹ
	s16	ñ 'ʸ@@'
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
*/
bool DefineWord(CanHeader* ch,int fd UNUSED)
{
    DEBUGLOG(CH_CANNA,"\n"); //ؿ̾ɽ
    return reg_or_unreg_word(ch,ImmRegisterWordW);
}

/*0e ñ:񤫤ñ롥
׵ѥå(Type 12)
	i16	ƥֹ
	s16	ñ 'ʸ@@'
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ : 0 / 顼: 1
*/
bool DeleteWord(CanHeader* ch,int fd UNUSED)
{
    DEBUGLOG(CH_CANNA,"\n"); //ؿ̾ɽ
    return reg_or_unreg_word(ch,ImmUnregisterWordW);
}

bool set_yomi_str(CannaContext_t* cx,HIMC imc,unsigned sentence_mode,unsigned notify_cmd,uint16_t* yomi,int32_t fer_mode)
{
#ifdef SETCONTEXT_FAIL
    SetCurrentImc(imc,TRUE);
#else
    ImmSetOpenStatus(imc,TRUE);
    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0); //Ƚλ򤷤ʤ翷HWNDǤΥǡĤäƤȤ롣
#endif

    ImmSetConversionStatus(imc,CONV_MODE,sentence_mode);

    /* ???
       ''(FULLWIDTH MACRON)Ȥe-a1b1u16ˤU-ffe3ˤʤ뤬ɤʸˤ
       ImmNotifyIME()Ԥ롣줬'~'˽񤭴롣
       ''(e-a1c0,u-ff3c)Ʊͤäʤ
    */
    for(uint16_t* p=yomi; *p!=0; ++p){
	switch(*p){
	case 0xffe3: *p='~'; break;
	case 0xff3c: *p='\\'; break;
	}
    }
    int r = ImmSetCompositionStringW(imc,SCS_SETSTR,yomi,WcLen(yomi)*2,NULL,0);

    if(r){
	if((r=ImmNotifyIME(imc,NI_COMPOSITIONSTR,notify_cmd,0))){
	    cx->FerMode = fer_mode;
	    cx->Conv = 0;
	}else
	    INFOLOG(CH_CANNA,"fail ImmNotifyIME()\n");
    }else
	ERRORLOG(CH_CANNA,"fail ImmSetCompositionStringW()\n");
    return r!=0;
}

/*0f Ѵ:ɤߤΤʸФϢʸѴ⡼ɤǤʴѴԤ
׵ѥå(Type 14)
	i32	⡼  RkwBgnBunmode
	i16	ƥֹ
	s16	ɤ 'ʸ@@'
ѥå(Type 7)
	i16	ʸ  顼: 1
	s16	ʸκͥΥꥹ
*/
bool BeginConv(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    bool r=false;
    HIMC imc;
    
    uint16_t* yomi = Req14(ch,&mode,&cxn);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx!=NULL){
	FromClientToU16(cx,yomi);
	DEBUGLOG(CH_CANNA,"mode 0x%x, context %hd, '%W' [%*.2D] u16 %d fd %d\n",mode,cxn,yomi,WcLen(yomi),yomi,((cx->Flags & USE_UTF16)!=0),fd);
	r = set_yomi_str(cx,imc,IME_SMODE_PHRASEPREDICT,CPS_CONVERT,yomi,mode);
	ImmReleaseContext(cx->Win,imc);
    }else{
	DEBUGLOG(CH_CANNA,"context %hd NOT FOUND [%*.2D]\n",cxn,WcLen(yomi),yomi);
    }
    return r ? wm_ime_composition(cx,ch->Major,0) : (cx->Conv=-1,Reply5(ch->Major,ch->Minor,-1));
}

//Ѵ⡼ɤɲäο֤
//append_fer_cand()⻲
int fer_mode_num(int32_t mode)
{
    int count;
    for(count=0; (mode&RK_XFERMASK)!=0; mode>>=RK_XFERBITS){
	//⡼0x0fϽ롣 ???Ϥʤ
	if((mode & RK_XFERMASK) != RK_XFERMASK)
	    ++ count;
    }
    return count;
}

/*
  ߤѴ̤ΥꥹȤ롣ꥹȽλΥ̥ʸɲä롣
  ʸɤu16
  ͡ʸ
*/
int current_cand_list(int clstart,Array* lst,const CannaContext_t* cx,HIMC imc)
{
    int st = cx->FixedNum; //ResizePause֤ʸʸʹߤǤϤʤʸ
    Array u16;

    //ArDec(ArCopy(lst,&cx->FixedStr)); //ꥹȽλޡ롣
    
    ArNew(&u16,2,NULL);
    for(; ClauseStr(imc,cx,GCS_COMPSTR,clstart,clstart+1,ArClear(&u16),false)!=NULL; ++clstart){
	char at = GetAttr(imc,clstart,cx);
	if(at!=ATTR_TARGET_CONVERTED && at!=ATTR_CONVERTED && at!=ATTR_FIXEDCONVERTED)
	    break; //ޤѴƤʤФǽ
	ArAddAr(lst,&u16);
	++ st; //ͭʸο
    }
    if(st > 0){
	ArAdd1(lst,&(uint16_t){0}); //ꥹȽλޡ
    }
    ArDelete(&u16);
    return st;
}

void dump_cand_list(int num,const Array* ws)
{
    uint16_t* str;
    for(int index=0; (str=ListInc(ws,index))!=NULL; ++index){
	MESG("'%W' [%*D]\n",str,WcLen(str)*2,str);
    }
    MESG("list=%d\n",num);
}

/*
  begin_convert,resize_pause³
  WM_IME_COMPOSITIONν
  Context[cx].Convʸֹ

  ??? 1.5.1ޤǤϲäƤåޤƽƤ1.6.0ǤѴؿ
  Ƥå롼פ˹ԤľܤƤ֤Ȥˤatok21Ǥʤ
  ۤimeǤϤɤ å륿ߥ󥰤Ѵ٤ƽäȤ
  ޤʤΤ
  ä˼ưѴξ硢ŪѴ򤷤Ƥ櫓ǤϤʤä夹ˤδؿƤǤ뤬פʸƱ˹Ԥ꤬ꤽʵ롣
  Ф餯ǤäƤߤơи᤽

  clstart=ꥹȤƬʸֹ档
*/
bool wm_ime_composition(CannaContext_t* cx,char mj,int clstart)
{
    HIMC imc = ImmGetContext(cx->Win);
    DEBUGDO(CH_CANNA,{MESG("major code 0x%hhx, target clause number %d\n",mj,cx->Conv);
	    DbgComp(imc,__func__);});

    SaveFixedClause(imc,cx); //Ѵ뤿Ӥ˸ʸϾ񤭤ƤޤΤ¸롣

    Array candlist;
    int st = current_cand_list(clstart,ArNew(&candlist,2,NULL),cx,imc);
    DEBUGDO(CH_CANNA,dump_cand_list(st?st+clstart:st,&candlist));
    /*ResizePause֤ꥹȤϥʸᤫʸƬʸᤫǽʸޤǡ
      current_cand_list֤ͤϥʸʹߤʸʤΤǡclstartûʸˤ롣 */
    if(st > 0){
	FromU16ToClient(cx,&candlist);
	st += clstart;
    }
    bool ret = Reply7(mj,0,st,ArAdr(&candlist),ArUsing(&candlist));
    cx->Conv = -1;
    ImmReleaseContext(cx->Win,imc);
    ArDelete(&candlist);
    return ret;
}

/*
  ѴֹѴꥹȥڡֹȥڡֹˤ롣
  䥦ɥФʤȤ *page=-1
  Ƭλ顼λ-1

  !!! GetCandidacyListΥ⡼ɤɲä줿ɤߤʤɤ򤵤줿Ϥɤ롩
  ڡʤΤǥ顼ˤʤ롣
*/
int page_index(int cln,Array* candlistpage,int index,int* page)
{
    if(index > 0){ //Ƭʳ
	if(cln >= candlistpage->use){
	    *page = CANDLISTMAX; //ʸǸϽФƤʤ
	}else{
	    CandListPageInfo* pi = ArElem(candlistpage,cln);
	    if(pi->Seq > 0)
		*page = -1; //䥦ɥʤ
	    else{
		for(*page=0; *page<CANDLISTMAX; ++*page){
		    if(pi->Size[*page] == 0){ //ꥹȤʤ
			MESG("clause %d:candidate list page %d is none\n",cln,*page);
			index = -1;
			break;
		    }
		    if(index < pi->Size[*page])
			break;
		    index -= pi->Size[*page];
		}
	    }
	}
	if(*page == CANDLISTMAX){
	    DEBUGLOG(CH_CANNA,"clause %d:candidate page not found\n",cln);
	    index = -1;
	}
    }else{
	DEBUGLOG(CH_CANNA,"clause %d:first candidate word\n",cln);
	index = -1;
    }
    DEBUGLOG(CH_CANNA,"clause %d --> page %d,index %d\n",cln,*page,index);
    return index;
}

//ǽŪѴimeȿǤ
void update_cand(HIMC imc,const int16_t* candnum,int len,Array* pi,const CannaContext_t* cx)
{
    for(int clnum=cx->FixedNum; clnum<len; ++clnum,++candnum){
	int cn,page;
	if((cn=page_index(clnum,pi,*candnum,&page))>=0){
	    switch(SetTarget(imc,clnum,cx)){
	    case ChangeTargetSuccess:
		if(page >= 0){
		    if(ImmNotifyIME(imc,NI_OPENCANDIDATE,page,0) &&
		       ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,page,cn+WimeData.CandIndexStart)){
			DEBUGLOG(CH_CANNA,"candidate page %d, index %d\n",page,cn);
		    }else
			INFOLOG(CH_CANNA,"fail ImmNotifyIME\n");
		}else{
		    while(--cn >= 0){
			DEBUGLOG(CH_CANNA,"cand loop counter %d:\n",cn);
			ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
		    }
		}
	    case ChangeTargetFixed:
		break;
	    case ChangeTargetFail:
		ERRORLOG(CH_CANNA,"fail SetTarget\n");
	    }
	}
    }
}

/*10 Ѵλ:ߤΤʴѴȤλɬפ˱ƳؽԤ
׵ѥå(Type 10)
	i16	ƥֹ
	i16	ʸ
	i32	⡼  0ʤؽʤ  RkwEndBunmode
	i16[]	ʸΥȸֹꥹ
ѥå(Type 2)
	i8	λ  : 0/顼: 1
ʸʤ鸽ߤθǳꤹ롣
*/
bool EndConv(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,clses;
    int32_t mode;
    char st=-1;
    HIMC imc;

    int16_t* candnums = Req10((Req10_t*)ch,&cxn,&clses,&mode);
    DEBUGLOG(CH_CANNA,"context %hd, clauses %hd, mode %d, candidate list {%#*.2D}\n",cxn,clses,mode,(int)clses,candnums);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx!=NULL){
	//??? mode!=1ϥ󥻥ȤƤΤ
	if(mode==1){
	    update_cand(imc,candnums,clses,&cx->CandInfo,cx);
	    st = ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_COMPLETE,0);
	    if(st)
		DEBUGDO(CH_CANNA,DbgComp(imc,__FUNCTION__));
	}else{
	    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_REVERT,0);
	    st = ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
	}
	if(!st)
	    INFOLOG(CH_CANNA,"fail ImmNotifyIME\n");
	ImmNotifyIME(imc,NI_CLOSECANDIDATE,0,0); //???ʸɬפ
#ifdef SETCONTEXT_FAIL
	SetCurrentImc(imc,FALSE);
#else
	ImmSetOpenStatus(imc,FALSE);
#endif
	ImmReleaseContext(cx->Win,imc);

	//ResetContext()ǥե饰ꥢƤޤUSE_UTF16ϻĤƤ
	unsigned save_flag = (cx->Flags & USE_UTF16);
	ResetContext(cx)->Flags |= save_flag;
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*
  ⡼ɤˤäyomi(u16,Ⱦѥ)ѴƸꥹȤɲä롣
  ɲä֤
  ??? ⡼ɤ0xf(֤RK_CTRLHENKAN)ʤΤϲ
*/
int append_fer_cand(int mode,Array* lb,const Array* yomi)
{
    int count=0;
    for(; (mode&RK_XFERMASK)!=0; mode>>=RK_XFERBITS){
	uint16_t* zk = NULL;
	switch(mode & RK_XFERMASK){
	case RK_HFER: //Ⱦʸ
	    DEBUGLOG(CH_CANNA,"Hankaku\n");
	    ArAddAr(lb,yomi);
	    break;
	case RK_KFER: //
	    DEBUGLOG(CH_CANNA,"Katakana\n");
	    zk = U16HanToZenKata(NULL,NULL,ArAdrC(yomi),-1);
	    ArAddN(lb,zk,WcLen(zk)+1);
	    break;
	case RK_XFER: //Ҥ餬 ??? RK_ZFERȤΰ㤤ϡ
	    DEBUGLOG(CH_CANNA,"Hiragana\n");
	    zk = U16HanToZenHira(NULL,NULL,ArAdrC(yomi),-1);
	    ArAddN(lb,zk,WcLen(zk)+1);
	    break;
	case RK_ZFER: //ʸ
	    DEBUGLOG(CH_CANNA,"Zenkaku\n");
	    zk = U16HanToZenHira(NULL,NULL,ArAdrC(yomi),-1);
	    ArAddN(lb,zk,WcLen(zk)+1);
	    break;
	default:
	    DEBUGLOG(CH_CANNA,"unknown mode %d(0x%x)\n",mode & RK_XFERMASK,mode & RK_XFERMASK);
	    
	}
	++count;
	free(zk);
    }
    return count;
}

/*???
  atok2008ǤѴϸ촴롣ʤǤ꤬ʤޤɬס
  windowsǤθꥹȥɥǤ꤬ʤøɽƤ롣
  ꤬ʤμˡ狼ʤimm apiˤ̵
  Ȥꤢ򣱤Ĥ򤷡ΤȤѴʸФ
  ʥ饤ȤϤȤˤ롣
  [wine1.1.22]vje-dǤImmNotifyIME()ƤǤimcʤ褯狼ʤΤ
  vjeξGetCandidateA()ȤȤˤ롣
*/
void GetCandidateAtok(HIMC imc,const CannaContext_t* cx,Array* clist,int clnum,unsigned listnum,CANDIDATELIST* cb)
{
    for(unsigned cannum=0; cannum<cb->dwCount; ++cannum){
	if(!ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,listnum,cannum+WimeData.CandIndexStart)){
	    INFOLOG(CH_CANNA,"fail ImmNotifyIME(NI_SELECTCANDIDATESTR)\n");
	    break;
	}
	ClauseStr(imc,cx,GCS_COMPSTR,clnum,clnum+1,clist,false);
    }
}
/* cbꥹ(u16)롣ꥹȤνλޡϤĤʤ
   clist==NULLΤȤϲ֤ʤ
*/
void GetCandidateW(HIMC imc,const CannaContext_t* cx,Array* clist,int clnum,unsigned listnum,CANDIDATELIST* cb)
{
    for(unsigned cannum=0; cannum<cb->dwCount; ++cannum){
	uint16_t* u16 = (uint16_t*)((char*)cb + cb->dwOffset[cannum]);
	ArAddN(clist,u16,WcLen(u16)+1); //u16Τޤclistˤ롣
    }
}	

/*
  Ѵu16ˤƥꥹȤɲä롣ꥹȽλޡϤĤʤ
  clistblocksize:2(wchar) NULLΤȤϲ֤ʤ
  ꥹȤο(0)֤
*/
int lookup_cand_win(HIMC imc,Array* clist,CandListPageInfo* pi,int clnum,const CannaContext_t* cx)
{
    Array candpage;
    ArNew(&candpage,1,NULL);
    int cand_count=0;
    unsigned listnum=0;
    do{
	unsigned n;
	if((n = ImmGetCandidateListW(imc,listnum,NULL,0)) == 0){
	    DEBUGLOG(CH_CANNA,"page %d has no candidate list\n",listnum);
	    break;
	}
	DEBUGLOG(CH_CANNA,"ImmGetCandidateList:page %d, size %u\n",listnum,n);
	ArAlloc(&candpage,n);
	ImmGetCandidateListW(imc,listnum,ArAdr(&candpage),ArUsingBytes(&candpage));

	CANDIDATELIST* cb = ArAdr(&candpage);
	cand_count += cb->dwCount;
	pi->Size[listnum] = cb->dwCount;
	(*WimeData.GetCandidate)(imc,cx,clist,clnum,listnum,cb);
    }while(++listnum<CANDLISTMAX && ImmNotifyIME(imc,NI_CHANGECANDIDATELIST,listnum,0));

#if 1
    //裱᤹
    if(listnum > 0)
	ImmNotifyIME(imc,NI_CHANGECANDIDATELIST,0,0);
    if(cand_count > 0)
	ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,0,WimeData.CandIndexStart);
#else
    ImmNotifyIME(imc,NI_CLOSECANDIDATE,0,0);
    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
    //??? ̤äƤޤΤǡѴ롣ʤǡ
#endif

    ArDelete(&candpage);
    return cand_count;
}

//[3.4.4,r9] 򤵤Ƥֹ(0)֤
int cand_index(HIMC imc)
{
    int idx=-1;
    int sz = ImmGetCandidateList(imc,0,NULL,0);
    if(sz != 0){
	Array candpage;
	ArNew(&candpage,1,NULL);
	CANDIDATELIST* cb = ArAlloc(&candpage,sz);
	ImmGetCandidateList(imc,0,cb,ArUsingBytes(&candpage));
	idx = cb->dwSelection;
	ArDelete(&candpage);
    }
    return idx;
}

/*
  Ѵu16ˤƥꥹȤɲä롣ꥹȽλޡϤĤʤ
  euclistblocksize:2(wchar) NULLΤȤϲ֤ʤ
  ꥹȤο(0)֤
*/
int make_cand_list(HIMC imc,Array* clist,CandListPageInfo* pi,int clnum,CannaContext_t* cx)
{
    int count=0;
    bool open_cand_win;

    /*!!!
      "䥦ɥɽޤǤɬפѴ"ΤȤImmGetCandidateListϣ֤ImmNotifyIMENI_OPENCANDIDATEꤷƤ䥦ɥɽʤʤȤʤʤΤǡimcϣܤѴ֤ǤȤơ̤Ѵ֤ˤʤޤImmNotifyIMEѴΤӤѴ̤Ͽ롣
      ˡѴꥹȤä硢ؤΥॢǤʤܤθǳꤷ٣ѴʤФʤʤʤΤǡѴåĴ١WM_IME_NOTIFY(IMN_OPENCANDIDATE)褿ƤޤǤƱѴ롣
      ƤʸǺǽ򤹤롢ȤϤޤ̵ˡˤнϴñ(ޤǤˡǤ򤷤Ƥ)CandListPageInfoɬפʤʤΤɤ뤫
      uimϲ뤿ӤʸθĴ٤ä㤯٤ʤʡᤫ
      [3.4.4,r9]ImmNotifyIMEѴƤäưȤ°̤ѴʤȤ(send_keyѴƤȤ?)ߤθֹ椬0äɤĴ٤뤳Ȥˤ롣
    */
    do{
	ClauseStr(imc,cx,GCS_COMPSTR,clnum,clnum+1,clist,false);
	//DEBUGLOG(CH_CANNA,"cand:%W\n",ArAdr(&u16));
	++count;
	cx->Flags &= ~CATCH_OPEN_CAND;
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	flush_msg_loop();
	open_cand_win = ((cx->Flags & CATCH_OPEN_CAND)!=0);
    }while(!open_cand_win &&
	   GetAttr(imc,clnum,cx)!=ATTR_TARGET_NOTCONVERTED &&
	   !(count>1&&cand_index(imc)==0));

    if(open_cand_win){
	//ꥻåȤƤľ
	DEBUGLOG(CH_CANNA,"retry call lookup_cand_win()\n");
	count = lookup_cand_win(imc,ArClear(clist),pi,clnum,cx);
    }else{
	//ܤѴ֤᤹
	if(GetAttr(imc,clnum,cx)==ATTR_TARGET_NOTCONVERTED){
	    DEBUGLOG(CH_CANNA,"reset first condition\n");
	    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	}else{
	    DEBUGLOG(CH_CANNA,"already first condition,index %d\n",cand_index(imc));
	}
	pi->Seq = count;
    }
    return count;
}

static inline Array* han2zenhira(Array* str){
    return ArSetUsing(str,WcLen(U16HanToZenHira((uint16_t*)ArAdr(str),NULL,(uint16_t*)ArAdr(str),-1))+1);
}

/*11 ׵:ꤵ줿ʸΤ٤Ƥθʸɤߤ롥
׵ѥå(Type 6)
	i16	ƥֹ
	i16	ʸֹ
	u16	Хåե
ѥå(Type 7)
	i16	  顼: 1
	s16	ʸΥꥹ+ɤ '@@...@@@@ɤ@@@@'
֤ (Ѵο+modeˤɤߤο)ǸɲäɤߤϴޤޤƤʤ
*/
bool GetCandiList(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cls_num,cand_count=-1;
    uint16_t bufsize;
    Array clist;
    HIMC imc;

    Req6(ch,&cxn,&cls_num,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, clause-number %hd, buffer size %hu\n",cxn,cls_num,bufsize);
    ArNew(&clist,2,NULL);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	switch(SetTarget(imc,cls_num,cx)){ //ʸѹ
	case ChangeTargetSuccess:
	    if(cls_num < ArUsing(&cx->CandInfo))
		//ǰΤξϾäƤ
		*(CandListPageInfo*)ArElem(&cx->CandInfo,cls_num) = (CandListPageInfo){0};
	    else
		ArAlloc(&cx->CandInfo,cls_num+1); //ʸޤǤϳݤ

	    /*[r11]send_keyѴƤȤϤǤ˲ܤθˤʤäƤΤǡǽθ᤹*/
	    if(cx->Flags & CATCH_OPEN_CAND){
		cx->Flags &= ~CATCH_OPEN_CAND; //???memo0222
		ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,0,WimeData.CandIndexStart);
	    }
	    cand_count = make_cand_list(imc,&clist,ArElem(&cx->CandInfo,cls_num),cls_num,cx);
#if 0
	    //[1.8.5]ɤߤˤʤΤcand_count0ˤʤ뤳Ȥ̵Ȼפ
	    if(cand_count == 0){
		/* Ѵ̰ʳ˸䤬ʤѴ̤ */
		ClauseStr(imc,cx,GCS_COMPSTR,cls_num,cls_num+1,&clist,false);
		++cand_count;
	    }
#endif
	    //ɤߤɲ
	    Array u16;
	    ClauseStr(imc,cx,GCS_COMPREADSTR,cls_num,cls_num+1,ArNew(&u16,2,NULL),false);
	    cand_count += append_fer_cand(cx->FerMode,&clist,&u16); //⡼ɤˤäƸꥹȤɲä
	    ArAddAr(&clist,han2zenhira(&u16)); //ɤߤɲ ???ϸ˥ȤʤΤ
	    ArAdd1(&clist,&(uint16_t){0});	//ꥹȽλ򼨤̥ʸ
	    ArDelete(&u16);

	    DEBUGDO(CH_CANNA,dump_cand_list(cand_count,&clist));
	    FromU16ToClient(cx,&clist); //ꥹΤ쵤Ѵ롣

	    if(ArUsingBytes(&clist) > bufsize){
		ERRORLOG(CH_CANNA,"bufsize too small,need %d\n",ArUsingBytes(&clist));
#if 0
		ArClear(&euclist);
		cand_count = -1;
		/*???Хåեɥ쥹Ϥ줿櫓ǤʤΤ˥Хåեǧ뤳Ȥ˰̣Τ?
		  [180222]¿ȤϤ줿Хåեʾ礭ˤʤȤ뤬
		  ǥ顼֤uimϸǤޤäƤޤ顼ˤ٤ʤΤ褯ʬʤ
		  uimϥХåեʾΥǡ֤Ƥư褦ʤΤǡˤƤ
		*/
#endif
	    }
	    break;
	case ChangeTargetFixed:
	    DEBUGLOG(CH_CANNA,"this clause is fixed\n");
	    break;
	case ChangeTargetFail:
	    INFOLOG(CH_CANNA,"fail SetTarget\n");
	}
	ImmReleaseContext(cx->Win,imc);
    }
    bool ret = Reply7(ch->Major,ch->Minor,cand_count,ArAdr(&clist),ArUsing(&clist));
    ArDelete(&clist);
    return ret;
}

/*12 ɤߤʼ:ʸɤߤʤ롥
׵ѥå(Type 6)
	i16	ƥֹ
	i16	ʸֹ
	u16	ɤߤΥХåե
ѥå(Type 7)
	i16	ɤߤĹ  顼: 1
	s16	ɤ  'ʸ@@'
*/
bool GetYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cln;
    uint16_t bufsize;
    bool st=false;
    Array yomi;
    HIMC imc;

    ArNew(&yomi,2,NULL);
    Req6(ch,&cxn,&cln,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, bufsize %hd\n",cxn,cln,bufsize);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	if(ClauseStr(imc,cx,GCS_COMPREADSTR,cln,cln+1,&yomi,true) != NULL){
	    if(ArUsingBytes(&yomi) <= bufsize){
		DEBUGLOG(CH_CANNA,"yomi:[%W] %d\n",ArAdr(&yomi),ArUsing(&yomi)-1);
		st = true;
	    }else{
		INFOLOG(CH_CANNA,"buffer too small\n");
	    }
	    FromU16ToClient(cx,&yomi);
	}else{
	    DEBUGLOG(CH_CANNA,"fail GetClause\n");
	}
	ImmReleaseContext(cx->Win,imc);
    }
    st = Reply7(ch->Major,ch->Minor,(st ? ArUsing(&yomi)-1:-1),ArAdr(&yomi),ArUsing(&yomi));
    ArDelete(&yomi);
    return st;
}

//եȥξ֤򥻥åȤ
void set_state(unsigned char state,uint16_t vk,unsigned convmode)
{
    if((vk & 0xff00)!=0 || (convmode & IME_CMODE_ROMAN)==0){
	unsigned char keytab[256];
	GetKeyboardState(keytab);

	if((vk & VKMODKEY(WINMODKEY_SHIFT)) != 0)
	    keytab[VK_SHIFT]=state;
	if((vk & VKMODKEY(WINMODKEY_CTRL)) != 0)
	    keytab[VK_CONTROL]=state;
	if((vk & VKMODKEY(WINMODKEY_ALT)) != 0)
	    keytab[VK_MENU]=state;
	if((vk & VKMODKEY(WINMODKEY_LOCK)) != 0)
	    keytab[VK_CAPITAL]=state?1:0; //??? VK_OEM_ATTN
	if((convmode & IME_CMODE_ROMAN) == 0)
	    keytab[VK_KANA]=state?1:0;

	SetKeyboardState(keytab);
    }
}

#define KEYUP (1<<31)

/*??? '>','?'ʤɥեȥɬפʾ硢SetKeyboardState()̵֤ѹƤ롣 SendInput()ʤɤȤ٤ ⤽⺬Ū˥ץְäƤ뵤롣
  vk=ۥɡ壸ӥåȤˤϥեȾ֤򥻥åȤ롣
*/
bool proc_key_vk(uint16_t vk,HWND wh,HKL kl,unsigned convmode)
{
    bool st = false;
    uint32_t vkch = vk&0xff; //ۥ(եȤʤ)
    uint32_t sc = MapVirtualKeyEx(vkch,MAPVK_VK_TO_VSC,kl); //ۥɢ󥳡
    uint32_t pk = (sc<<16)|1; //ImmProcessKeyѤΥ󥳡
    UINT msg = WM_NULL;

    DEBUGLOG(CH_CANNA,"vk 0x%hx, sc 0x%x, wh %p, convmode 0x%x(roman %d)\n",vk,sc,wh,convmode,(convmode&IME_CMODE_ROMAN)!=0);
#if 0
    //!!! wm_wime_set_focus()SetFocus()褦ˤ
    if(GetFocus() != wh) //???Ĵ٤ˤʤSetFocusϤᤫ
	SetFocus(wh);
#endif
    set_state(0x80,vk,convmode);
    if(ImmProcessKey(wh,kl,vkch,pk,0))
	msg = WM_KEYDOWN;
    else if(ImmProcessKey(wh,kl,vkch,pk|KEYUP,0))
	msg = WM_KEYUP;
    if(msg != WM_NULL){
	if(ImmTranslateMessage(wh,msg,VK_PROCESSKEY,pk)){
	    st = true;
	}else{
	    /*???atok2017ǤImmTranslateMessagefail֤
	     failǤϤƤ褦2017ΤȤϤȤꤢtrue֤Ƥ*/
	    FATALLOG(CH_CANNA,"fail ImmTranslateMessage(), vkey 0x%hx, scancode 0x%x\n",vk,(unsigned)sc);
	    if((WimeData.ImeVersion)() == 30){
		DEBUGLOG(CH_CANNA,"return true\n");
		st = true;
	    }
	}
    }else{
	DEBUGLOG(CH_CANNA,"fail ImmProcessKey(), vkey 0x%hx, scancode 0x%x\n",vk,(unsigned)sc);
    }
    set_state(0,vk,convmode);
    return st;
}

//Ѵ⡼ɤϥ޻ʤΤwimeƤФʤ褦ˡ
bool proc_key_ch(char ch,HWND wh,HKL kl)
{
    return proc_key_vk(VkKeyScanEx(ch,kl),wh,kl,CONV_MODE); //ʸɢۥ
}

/*
  utf16ѤҤ餬ʤ޻ˤHWND롣
  yomiѤҤ餬ʤ˸ǤΤZen2Roman()ϤäȴñˤʤΤasciiǤ褦ˤƤΤ
  ɤʤäƤ롣ά뤫
*/
bool send_roman(HWND wh,HKL kl,const uint16_t* yomi,int len)
{
    bool st=true;
    if(yomi != NULL){
	for(; (len>0 || (len<0 && *yomi!=0)) && st; ++yomi,--len){
	    for(const char* rmj=U16Zen2Romaji(*yomi); *rmj!=0; ++rmj){
		if(!proc_key_ch(*rmj,wh,kl)){
		    st = false;
		    break;
		}
	    }
	}
    }
    return st;
}

//beg<=...<endޤǤɤߤѤˤȤĹȾѥʤûʤǽ롣
//str!=NULLʤʸ֤ꥢƤȡ
int combined_yomi_len(CannaContext_t* cx,HIMC imc,int beg,int end,Array* str)
{
    Array compread;
    ArNew(&compread,2,NULL);
    if(str == NULL)
	str = &compread;
    int len = ArUsing(ClauseStr(imc,cx,GCS_COMPREADSTR,beg,end,str,true))-1;
    if(len < 0)
	len = 0;
    ArDelete(&compread);
    return len;
}

/*YomiBufStart򹹿롣
  SubstYomiǼưѴʸ᤬֤"cannaɤߥХåե"ϥꥢ롣
  imcǤϥꥢϤʤΤǡѴ줿ɤߤμcannaɤߥХåեγϰ֤Ȥ롣
 */
void update_buf_start(CannaContext_t* cx,HIMC imc)
{
    int conved=0;
    for(int cln=ImcClauseInfo(imc,GCS_COMPSTR,NULL); --cln>=0;){
	char at=GetAttr(imc,cln,cx);
	if(at==ATTR_TARGET_CONVERTED||at==ATTR_CONVERTED)
	    ++conved;
    }
    if(conved != cx->ConvertedCl){
	cx->ConvertedCl = conved;
	cx->YomiBufStart = combined_yomi_len(cx,imc,0,conved,NULL);
	DEBUGLOG(CH_CANNA,"new bufstart %d\n",cx->YomiBufStart);
    }
}

/*0x13 ưѴ:ưѴ⡼ɻɤߥХåե(ưѴѴѤɤߤʤ¸ΰ)ƤѹѴԤ
׵ѥå(Type 4)
	i16	ƥֹ
	u16	ϥեå
	u16	λեå
	u16	ɤߤĹ
	s16	ɤ  'ʸ@@'
ѥå(Type 7)
	i16	ʸ  顼: 1
	s16	ʸκͥ  '@@...@@@@@@'
*/
bool SubstYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t beg,end,len;
    bool st=false;
    HIMC imc;
    
    uint16_t* yomi = Req4(ch,&cxn,&beg,&end,&len);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	Array compread;
	HKL kl = GetKeyboardLayout(0);
	FromClientToU16(cx,yomi);
	DEBUGLOG(CH_CANNA,"context %hd, begin %hd, end %hd, length %hd, '%W'\n",cxn,beg,end,len,yomi);
	int cur_yomi_len = combined_yomi_len(cx,imc,0,-1,ArNew(&compread,2,NULL));
	DEBUGLOG(CH_CANNA,"bufstart %d read %d\n",cx->YomiBufStart,cur_yomi_len);
	beg += cx->YomiBufStart; //imcɤʸǤΥեåȤˤ롣
	end += cx->YomiBufStart;
	if(beg >= cur_yomi_len){
	    //ǸФ
	    if(len==0 || yomi==NULL){
		//Ѵ
		DEBUGLOG(CH_CANNA,"force conv\n");
		st = Reply5(ch->Major,ch->Minor,0); //ʸ֤FlushYomi롣
	    }else{
		//ɲ
		DEBUGLOG(CH_CANNA,"append [%*.2D]\n",len,yomi);
		send_roman(cx->Win,kl,yomi,-1);
		st = wm_ime_composition(cx,ch->Major,0);
	    }
	}else{
	    DEBUGLOG(CH_CANNA,"replace\n");
	    //beg<= ... <end ޤǤ֤롣
	    if(end == 0){
		//begin=end=0ʤΤ֤
		ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
		send_roman(cx->Win,kl,yomi,-1);
	    }else{
		//ʬ֤
		DEBUGLOG(CH_CANNA,"delete %d\n",cur_yomi_len-beg);
		for(int count=cur_yomi_len-beg; count>0; --count)
		    proc_key_ch('\b',cx->Win,kl); //begޤǤõ
		send_roman(cx->Win,kl,yomi,-1);
		if(cur_yomi_len > end){
		    //endʹ
		    DEBUGLOG(CH_CANNA,"rest [%*.2D]\n",cur_yomi_len-end,ArElem(&compread,end));
		    send_roman(cx->Win,kl,ArElem(&compread,end),cur_yomi_len-end);
		}
	    }
	    st = wm_ime_composition(cx,ch->Major,0);
	}
	update_buf_start(cx,imc);
	ImmReleaseContext(cx->Win,imc);
	ArDelete(&compread);
    }else{
	ERRORLOG(CH_CANNA,"context %hd NOT FOUND, begin %hd end %hd length %hd [%*.2D]\n",cxn,beg,end,len,len,yomi);
	st = Reply5(ch->Major,ch->Minor,-1);
    }
    return st;
}

/*
  ʸ򿷤ɤߤ֤ƺѴ롣
  clindex оʸ
  conv_cl ʸĴоݤˤʤǽʸ
 */
bool store_yomi(CannaContext_t* cx,HIMC imc,int clindex,const uint16_t* yomi_u16)
{
    Array* yomi_all = ArNew(NULL,2,NULL);
    if(clindex > 0){
	//clindexѴѤʸ(̥ʸϺƤ)
	ArDec(ClauseStr(imc,cx,GCS_COMPREADSTR,0,clindex,yomi_all,false));
    }

    //ʸοɤߤɲ
    uint16_t* new_cur_han = U16ZenToHan(NULL,NULL,yomi_u16,-1);
    ArAddN(yomi_all,new_cur_han,WcLen(new_cur_han));
    free(new_cur_han);

    //ĤʸϤȤɤʸ
    if(ClauseStr(imc,cx,GCS_COMPREADSTR,clindex+1,-1,yomi_all,false) != NULL){
	ArDec(yomi_all); //̥ʸƤ
    }
    ArDec(ArAdd1(yomi_all,&(uint16_t){0})); //Хåե˥̥ʸ񤭹Ǥʸˤϴޤʤ
    //DEBUGLOG(CH_CANNA,"'%W'\n",ArAdr(yomi_all));
    
    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
    bool st = true;
    if(!ImmSetCompositionStringW(imc,SCS_SETSTR,NULL,0,ArAdr(yomi_all),ArUsingBytes(yomi_all))
       || !ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0)){
	ERRORLOG(CH_CANNA,"fail set new yomi or convert:'%W'\n",ArAdr(yomi_all));
	st = false;
    }
    free(ArDelete(yomi_all));
    return st;
}

/*
  ʸɤߤĹdiffä롣
 */
bool resize_clause(CannaContext_t* cx,HIMC imc,int cl_index,int diff)
{
    Array yomi_cl;
    int clnum = ImcClauseInfo(imc,GCS_COMPREADSTR,ArNew(&yomi_cl,4,NULL));

    //оݤ򤵤ƤʤImmSetCompositionStringԤ롣
    SetTarget(imc,cl_index,cx);
    
    int id_in_imc = cl_index - cx->FixedNum; //imcʸֹ
    if(id_in_imc<0 || id_in_imc > clnum-1) //ʸֹ椬ϰϳ
	return false;

    int target_begin = ARVAL(int32_t,&yomi_cl,id_in_imc);
    int right_begin = ARVAL(int32_t,&yomi_cl,id_in_imc+1);
    int new_length = right_begin-target_begin+diff;
    DEBUGLOG(CH_CANNA,"diff %d index %d clnum %d new-len %d\n",diff,id_in_imc,clnum,new_length);
    
    if(diff < 0){
	//û롣
	if(new_length <= 0) //ʾ̤褦Ȥ
	    return true;
	//ǸΣʸäȤϤˣʸû롣
	Array yomi;
	ArDec(ClauseStr(imc,cx,GCS_COMPREADSTR,cl_index,cl_index+1,ArNew(&yomi,2,NULL),false));//̥ʸϺƤ
	if(new_length>=2 && U16CombineHanHira(ARELEM(uint16_t,&yomi,new_length-1))>0){
	    --new_length;
	}
	ArDelete(&yomi);
    }else{
	//Ĺ롣
	Array yomi;
	ArDec(ClauseStr(imc,cx,GCS_COMPREADSTR,cl_index,cl_index+2,ArNew(&yomi,2,NULL),false));	//ʸޤǼ롣
	DEBUGLOG(CH_CANNA,"total %d new-len %d\n",ArUsing(&yomi),new_length);
	if(id_in_imc == clnum-1) /*줬ǽʸʤ餳ʾĹǤʤ*/
	    return true;
	//ʤ⤦ʸФ
	if(new_length<ArUsing(&yomi) && U16CombineHanHira(ARELEM(uint16_t,&yomi,new_length))>0)
	    ++new_length;
	ArDelete(&yomi);
    }
    ARVAL(int32_t,&yomi_cl,id_in_imc+1) = target_begin+new_length;
    bool st=(ImmSetCompositionStringW(imc,SCS_CHANGECLAUSE,NULL,0,ArAdr(&yomi_cl),ArUsingBytes(&yomi_cl))!=0);
    if(st && cl_index < ArUsing(&cx->CandInfo)){
	//ʸȱʸ᤬ƶ뢪CandInfo򣰤᤹
	CandListPageInfo* clp = ArElem(&cx->CandInfo,cl_index);
	*clp = (CandListPageInfo){0};
	if(cl_index+1 < ArUsing(&cx->CandInfo))
	    *(clp+1) = (CandListPageInfo){0};
    }
    ArDelete(&yomi_cl);
    return st;
}

/*
  beginʾend̤ϰϤʸĹold_yomi_clƱˤ롣
 */
bool adj_clause(CannaContext_t* cx,HIMC imc,int begin,int end,Array* old_yomi_cl)
{
    bool st = true;
    Array new_yomi_cl;
    ArNew(&new_yomi_cl,4,NULL);
    DEBUGDO(CH_CANNA,DbgComp(imc,"starting cluase"));
    for(int index=begin; index<end; ++index){
	ImcClauseInfo(imc,GCS_COMPREADSTR,ArClear(&new_yomi_cl));
	int id_in_imc = index-cx->FixedNum;
	int diff = ARVAL(int32_t,old_yomi_cl,id_in_imc) - ARVAL(int32_t,&new_yomi_cl,id_in_imc);
	if(diff != 0){
	    DEBUGLOG(CH_CANNA,"current cl:%#*.4D,change #%d,add %d\n", ArUsing(&new_yomi_cl),ArAdr(&new_yomi_cl),id_in_imc,diff);
	    st = resize_clause(cx,imc,index-1,diff);
	    if(!st){
		DEBUGLOG(CH_CANNA,"fail ImmSetCompositionStringW:%#*.4D\n",ArUsing(&new_yomi_cl),ArAdr(&new_yomi_cl));
		break;
	    }
	}
    }
    ArDelete(&new_yomi_cl);
    return st;
}

/*0x14 ɤߤѹ:ʸɤߤʤѹʹߤʸѴ롥
׵ѥå(Type 11)
	i16	ƥֹ
	i16	ʸֹ
	s16	ɤ 'ʸ@@'
ѥå(Type 7)
	i16	ʸ  顼: 1
	s16	ʸκͥꥹ  '@@...@@@@@@'
ɤߤNULLΤȤʸ롣
*/
bool StoreYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,clindex;
    HIMC imc;
    bool st=false;

    uint16_t* new_cur_yomi = Req11(ch,&cxn,&clindex);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	FromClientToU16(cx,new_cur_yomi);
	DEBUGLOG(CH_CANNA,"context %hd, clause %hd, '%W'\n",cxn,clindex,new_cur_yomi);
	
	Array old_yomi_cl;
	int clnum = ImcClauseInfo(imc,GCS_COMPREADSTR,ArNew(&old_yomi_cl,4,NULL)); //ʸ
	if(clnum == 1 && new_cur_yomi == NULL){
	    //ʸ᤬Ĥʤ󥻥뤹롣
	    st = (ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0)!=0);
	}else{
	    if(store_yomi(cx,imc,clindex,new_cur_yomi) && adj_clause(cx,imc,0,clindex,&old_yomi_cl)){
		st = true;
		cx->Conv = clindex;
	    }
	}
	ArDelete(&old_yomi_cl);
	update_buf_start(cx,imc);
	ImmReleaseContext(cx->Win,imc);
    }else{
	ERRORLOG(CH_CANNA,"context %hd NOT FOUND, clause %hd, [%*.2D]\n",cxn,clindex,WcLen(new_cur_yomi),new_cur_yomi);
    }
    return st ? wm_ime_composition(cx,ch->Major,0) : Reply5(ch->Major,ch->Minor,-1);
}

//Ҥ餬ʤu16ȾѥʤˤȤʸ
int han_len(const uint16_t* u16)
{
    int len;
    free(U16ZenToHan(NULL,&len,u16,-1));
    return len-1;
}

/*0x15 ʸΤߤñʸѴ:ʸɤߤʤѹʸΤߤñʸѴ롥
׵ѥå(Type 11)
	i16	ƥֹ
	i16	ʸֹ
	s16	ɤ  'ʸ@@'
ѥå(Type 7)
	i16	ɤߤĹ  顼: 1
	s16	ñʸѴͥ '@@'
??? ɤȤ˸ƤФ p1׵p3ĹǤΤ
wime:ɤߤNULLΤȤꤷʸ(-1ΤȤߤʸ)Ѵ롣Ѵʸʸ֤
*/
bool StoreRange(CanHeader* ch,int fd)
{
    int16_t cxn,clindex;
    Array cstr;
    HIMC imc;
    
    ArNew(&cstr,2,NULL);
    uint16_t* yomi = Req11(ch,&cxn,&clindex);
    int16_t yomi_len = WcLen(yomi);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    DEBUGLOG(CH_CANNA,"StoreRange:cxn %hd index %hd yomi '%W'\n",cxn,clindex,yomi);
    if(cx != NULL){
	if(yomi==NULL){
	    //wime
	    if(clindex < 0)
		clindex = GetAttrCl(imc,ATTR_TARGET_CONVERTED,cx);
	    else
		SetTarget(imc,clindex,cx);
	    if(ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0)){
		ClauseStr(imc,cx,GCS_COMPSTR,clindex,clindex+1,&cstr,false);
		FromU16ToClient(cx,&cstr);
		DEBUGDO(CH_CANNA,DbgComp(imc,__FUNCTION__));
		DEBUGLOG(CH_CANNA,"target-cl-num %hd\n",clindex);
		yomi_len = ArUsing(&cstr)-1;
	    }else{
		DEBUGLOG(CH_CANNA,"fail NotifyIME\n");
		ArDelete(&cstr);
		yomi_len = -1;
	    }
	}else{
	    FromClientToU16(cx,yomi);
	    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, yomi '%W'\n",cxn,clindex,yomi);

	    Array old_yomi_cl;
	    ImcClauseInfo(imc,GCS_COMPREADSTR,ArNew(&old_yomi_cl,4,NULL)); //ʸ
	    DEBUGLOG(CH_CANNA,"orig cl:%#*.4D\n",ArUsing(&old_yomi_cl),ArAdr(&old_yomi_cl));

	    int id_in_imc = clindex-cx->FixedNum;
	    //ɤߤȥʸɤߤĹκ
	    int diff = han_len(yomi) - (ARVAL(int32_t,&old_yomi_cl,id_in_imc+1)-ARVAL(int32_t,&old_yomi_cl,id_in_imc));
	    //ʸ걦ˤʸγϰ֤diff롣
	    for(int index=id_in_imc+1; index<ArUsing(&old_yomi_cl); ++index){
		ARVAL(int32_t,&old_yomi_cl,index) += diff;
	    }
	    DEBUGLOG(CH_CANNA,"adj  cl:%#*.4D\n",ArUsing(&old_yomi_cl),ArAdr(&old_yomi_cl));
	
	    /*ʸϿɤߤ֤ʸĹϸƱˤ롣
	      ɤߤϣĤʸˤ뤳ȤñʸѴȤ롣
	    */
	    if(store_yomi(cx,imc,clindex,yomi) && adj_clause(cx,imc,0,ArUsing(&old_yomi_cl),&old_yomi_cl)){
		ClauseStr(imc,cx,GCS_COMPSTR,clindex,clindex+1,&cstr,false);
		FromU16ToClient(cx,&cstr);
		DEBUGDO(CH_CANNA,DbgComp(imc,__FUNCTION__));
	    }else
		yomi_len = -1;
	    update_buf_start(cx,imc);
	}
    }else{
    	ERRORLOG(CH_CANNA,"context %hd NOT FOUND, clause %hd [%*.2D]\n",cxn,clindex,yomi_len,yomi);
    }
    bool st = Reply7(ch->Major,ch->Minor,yomi_len,ArAdr(&cstr),ArUsing(&cstr));
    ArDelete(&cstr);
    return st;
}

/*0x16 ̤ʸ:̤ʸɤߤ롥
׵ѥå(Type 3)
	i16	ƥֹ
	u16	ɤߤΥХåե
ѥå(Type 7)
	i16	ɤߤĹ  顼: 1
	s16	̤ʸɤ 'ʸ@@'
̤ʸȤ̤ѴʸΤ褦
*/
bool GetLastYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,st=-1;
    uint16_t bufsize;
    Array yomi;
    HIMC imc;

    ArNew(&yomi,2,NULL);
    Req3(ch,&cxn,&bufsize);
    DEBUGLOG(CH_CANNA,"context %hd, bufsize %hd\n",cxn,bufsize);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	int n;
	if((n = GetAttrCl(imc,ATTR_INPUT,cx)) >= 0){
	    ClauseStr(imc,cx,GCS_COMPREADSTR,n,n+1,&yomi,true);
	    DEBUGLOG(CH_CANNA,"cl-num %d, string '%W'\n",n,ArAdr(&yomi));
	    FromU16ToClient(cx,&yomi);
	    st = ArUsing(&yomi)-1;
	}else{
	    //??? ̤ʸ᤬ʤȤϥ顼ʤΤ Ȥꤢｪλ롣
	    st = 0;
	    DEBUGLOG(CH_CANNA,"noting\n");
	}
	ImmReleaseContext(cx->Win,imc);
    }
    bool ret = Reply7(ch->Major,ch->Minor,st,ArAdr(&yomi),ArUsing(&yomi));
    ArDelete(&yomi);
    return ret;
}

/*0x17  Ѵ:̤ʸŪѴ롥
׵ѥå(Type 10)
	i16	ƥֹ
	i16	ʸֹ
	i32	⡼(0)
	i16[]	ʸΥȸֹ(ʸֹ+1)
ѥå(Type 7)
	i16	ʸ  顼: 1
	s16	ͥꥹ  '@@...@@@@@@'
*/
bool FlushYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cl;
    int32_t mode;
    bool st=false;
    HIMC imc;

    int16_t* cand = Req10((Req10_t*)ch,&cxn,&cl,&mode);
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, mode %d, candidate [%#*.2D]\n",cxn,cl,mode,(ch->Length-8)/2,cand);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	cx->Conv = 0;
	cx->FerMode = mode;
	if(GetAttrCl(imc,ATTR_INPUT,cx)>=0 || GetAttrCl(imc,ATTR_TARGET_NOTCONVERTED,cx)>=0){
	    //̤Ѵʸ᤬
	    if(ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0)){
		st = true; //ȤWM_IME_COMPOSITIONåνǤ
		update_buf_start(cx,imc);
	    }else
		INFOLOG(CH_CANNA,"fail ImmNotifyIME\n");
	}else{
	    //ǤѴѤ
	    DEBUGLOG(CH_CANNA,"already convert\n");
	    st = true; //??? ޤѴ
	}
	ImmReleaseContext(cx->Win,imc);
    }
    return st ? wm_ime_composition(cx,ch->Major,0) : Reply5(ch->Major,ch->Minor,-1);
}

/*0x18  ɤߥХåե:Ƭʸᤫ饫ʸޤɤߤɤߥХåե
׵ѥå(Type 10)
	i16	ƥֹ
	i16	ʸֹ
	i32	⡼  0ʤؽʤ   RkwRemoveBunmode
	i16[]	ʸΥȸֹ(ʸֹ+1)
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
???  StoreRangeƱĻȤ뤫狼ʤѴʸʾˤʤäƤФΤ?
  ѥåȤʸʸǤΤʸʹߤλĤʸ
*/
bool RemoveYomi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cl;
    int32_t mode;
    HIMC imc;
    char clall=-1; //ʸ

    int16_t* cand = Req10((Req10_t*)ch,&cxn,&cl,&mode);
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, mode %d, candidate [%#*.2D]\n",cxn,cl,mode,(ch->Length-8)/2,cand);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	//ƬclޤǤʸ
	bool st = true;
	if(mode && cl>=cx->FixedNum)
	    update_cand(imc,cand,cl-cx->FixedNum+1,&cx->CandInfo,cx);
	if(cl < cx->FixedNum-1){
	    //ʸΤߺ(ʸϣİʾĤ)
	    ListRemoveRange(&cx->FixedStr,0,cl);
	    ListRemoveRange(&cx->FixedYomi,0,cl);
	    cx->FixedNum -= cl+1;
	    DEBUGLOG(CH_CANNA,"fixed clauses %d\n",cx->FixedNum);
	}else{
	    //ʸ
	    ArClear(&cx->FixedStr);
	    ArClear(&cx->FixedYomi);
	    cl -= cx->FixedNum;
	    //imcƬclޤǤʸclΤߤˤ롣
	    Array yomi;
	    ClauseStr(imc,cx,GCS_COMPREADSTR,cl+1,-1,ArNew(&yomi,2,NULL),false);
	    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
	    ImmSetCompositionStringW(imc,SCS_SETSTR,NULL,0,ArAdr(&yomi),ArUsingBytes(&yomi));
	    ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	    cx->FixedNum = 0;
	    ArDelete(&yomi);
	}
	if(st){
	    clall = cx->FixedNum + ImcClauseInfo(imc,GCS_COMPSTR,NULL);

	    /* clޤǤθ󤬤оä˵ͤ */
	    if(cl+1 <= ArUsing(&cx->CandInfo)){
		ArRemove(&cx->CandInfo,0,cl+1);
		DEBUGLOG(CH_CANNA,"new candinfo length %d\n",ArUsing(&cx->CandInfo));
	    }
	}
	update_buf_start(cx,imc);
	ImmReleaseContext(cx->Win,imc);
    }
    //??? ȤꤢĤʸ֤Ƥߤ
    return Reply2(ch->Major,ch->Minor,clall);
}

/*19  :ꤵ줿񤫤餽μ˴ޤޤƤΤߤ롥
׵ѥå(Type 13)
	i16	ƥֹ
	s8	̾  '̾@'
	s16	ɤ  'ɤ@@'
	u16	ɤߤĹ
	u16	Хåե
	u16	ʻХåե
ѥå(Type 8)
	i16	  顼: 1
	s16	ʸ  '@@...@@@@@@'
	s16	ʻʸ  'ʻ@@...@@ʻ@@@@'
*/
bool GetSimpleKanji(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t yomi_len,cand_bufsize,hinshi_bufsize,*yomi;

    char* dic = Req13((Req13_t*)ch,&cxn,&yomi,&yomi_len,&cand_bufsize,&hinshi_bufsize);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, dic '%s', yomi '%S', yomi-len %hd, cand-bufsize %hd, hinshi-bufsize %hd\n",cxn,dic,yomi,yomi_len,cand_bufsize,hinshi_bufsize);
    free(yomi);
    return Reply5(ch->Major,ch->Minor,-1);
}

/*0x1a  ڤѹ:ꤵ줿ʸ򡤻ꤵ줿Ĺ˶ڤľơ٤ʴѴ롥
׵ѥå(Type 7)
	i16	ƥֹ
	i16	ʸֹ
	i16	ɤߤĹ ɤߤĹ / 2Ǥʸ̤ / 1Ǥʸ῭Ф
ѥå(Type 7)
	i16	ʸ  :ƬʸᤫǽʸޤǤʸ  顼:1
	s16	ʸκͥꥹ  '@@...@@@@@@'
ʸκͥꥹȤϡ*ʸ*ǽʸޤǤκ֤ͥ
ʸֹϣ
*/
bool ResizePause(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,clnum,count;
    bool st=false;
    HIMC imc;

    Req7(ch,&cxn,&clnum,&count);
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, count %hd\n",cxn,clnum,count);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx!=NULL && clnum>=cx->FixedNum){
	st = true;
	switch(count){
	case -1:
	    count=1;
	case 0: //[r26]ʸʸʾ˿ФȤȤ줬롣
	    break;
	case -2:
	    count=-1;
	    break;
	default:
	    if(count>0){
		count -= combined_yomi_len(cx,imc,clnum,clnum+1,NULL); //ʸФcount롣
	    }else{
		DEBUGLOG(CH_CANNA,"invalid count:%hd\n",count);
		st=false;
	    }
	}
	if(st && count!=0){
	    DEBUGLOG(CH_CANNA," --> count %hd\n",count);
	    st = resize_clause(cx,imc,clnum,count);
	}
    }
    if(imc!=NULL)
	ImmReleaseContext(cx->Win,imc);
    return st ? (cx->Conv=clnum,wm_ime_composition(cx,ch->Major,clnum)) : Reply5(ch->Major,ch->Minor,-1);
}

/*1b ʻ:ȸФʻʸǼ롥
׵ѥå(Type 8)
	i16	ƥֹ
	i16	ʸֹ
	i16	ȸֹ
	u16	ɤߤΥХåե
ѥå(Type 7)
	i16	ɤߤĹ  顼: 1
	s16	ʻʸ  'ʸ@@'
*/
bool GetHinshi(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cl,cand;
    uint16_t bufsize;

    Req8(ch,&cxn,&cl,&cand,&bufsize);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, candidate %hd, bufsize %hu\n",cxn,cl,cand,bufsize);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1c  Ǿ:ʸηǾ롥
׵ѥå(Type 9)
	i16	ƥֹ
	i16	ʸֹ
	i16	ȸֹ
	i16	ǾΥХåե
ѥå(Type 9)
	i16	ñ  顼: 1
	i32[]	Ǿ  {20(struct RkLex礭)ñ}Х
*/
bool GetLex(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cl,cand,bufsize;

    Req9(ch,&cxn,&cl,&cand,&bufsize);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, clause %hd, candidate %hd, bufsize %hu\n",cxn,cl,cand,bufsize);
    return Reply5(ch->Major,ch->Minor,-1);
}

/*1d  Ͼ:ȸ˴ؤϾ롥
׵ѥå(Type 7)
	i16	ƥֹ
	i16	ʸֹ
	i16	ȸֹ
ѥå(Type 4)
	i8	λ  : 0 / 顼: 1
	i32[]	Ͼ(28Х)  struct RkStat礭28Х
*/
bool GetStatus(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,clnum,cand;
    int datalen=0;
    char st=-1;
    HIMC imc;

    Req7(ch,&cxn,&clnum,&cand);
    DEBUGLOG(CH_CANNA,"context %hd, clause number %hd, candidate number %hd\n",cxn,clnum,cand);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	cx->RkSt.bunnum = clnum;
	cx->RkSt.candnum = cand;

	/* [1.8.4]uimǤϸꥹȤФˤapiƤФ餷Τǡ
	   Ĵ٤ */
	int cand_count=-1;
	CandListPageInfo* pi = ArElem(&cx->CandInfo,clnum);
	if(clnum>=ArUsing(&cx->CandInfo) || (pi->Seq==0 && pi->Size[0]==0)){
	    /* ʸǸꥹȤФƤʤȤ
	       䤬ʤäȤSize[0]0ˤʤ롣ꥹȤĴ٤ɤ
	       狼ʤΤǡΤȤϤƺĴ٤롣Τ˥ե饰ɲ
	       Τ⤦äȤ*/
	    ArAlloc(&cx->CandInfo,clnum+1);
	    pi = ArElem(&cx->CandInfo,clnum);
	    switch(SetTarget(imc,clnum,cx)){
	    case ChangeTargetSuccess:
		cand_count = make_cand_list(imc,NULL,pi,clnum,cx);
		break;
	    case ChangeTargetFixed:
		DEBUGLOG(CH_CANNA,"this clause is fixed\n");
		break;
	    case ChangeTargetFail:
		INFOLOG(CH_CANNA,"fail SetTarget\n");
	    }
	}else{ //pi!=NULLΤϤ
	    cand_count = pi->Seq;
	}
	if(cand_count >= 0){
	    cx->RkSt.diccand = cand_count; //pi->Seq; //[r12]cand_countȿǤƤʤä?
	    for(int n=0; n<CANDLISTMAX; ++n)
		cx->RkSt.diccand += pi->Size[n];
	    Array u16;
	    ArNew(&u16,2,NULL);
	    /*[1.8.5]䤬̵Ƥpi->Seq1ˤʤ(Ϥ)
	      if(cand_count == 0)     // Ѵ̰ʳ˸䤬ʤСѴ̤­
	      cx->RkSt.diccand++;
	    */
	    cx->RkSt.maxcand = cx->RkSt.diccand + fer_mode_num(cx->FerMode);
	    // ylen,klenϥХȿǤϤʤʸ(̥ʸʬ1Ƥ)
	    //ylenȾѥɽʸǽΤǡäѤѴʸĴ٤롣
	    cx->RkSt.ylen = combined_yomi_len(cx,imc,clnum,clnum+1,NULL);
	    cx->RkSt.klen = ArUsing(ClauseStr(imc,cx,GCS_COMPSTR,clnum,clnum+1,&u16,false))-1;
	    cx->RkSt.tlen = 1; //ȸιñ1ǤΤ
	    datalen = sizeof(RkStat)/4;
	    st = 0;
	    ArDelete(&u16);
	    DEBUGLOG(CH_CANNA,"bunnum %d, candnum %d, maxcand %d, diccand %d, ylen %d, klen %d, tlen %d\n",cx->RkSt.bunnum,cx->RkSt.candnum,cx->RkSt.maxcand,cx->RkSt.diccand,cx->RkSt.ylen,cx->RkSt.klen,cx->RkSt.tlen);
	}
	ImmReleaseContext(cx->Win,imc);

    }
    return Reply4(ch->Major,ch->Minor,st,(int32_t*)(&cx->RkSt),datalen);
}

/*1e  locale󥻥å
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	locale  'ʸ@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
*/
bool SetLocale(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* loc = Req15(ch,&mode,&cxn);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, locale %s\n",cxn,mode,loc);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1f  ưѴ:ưѴ⡼ɤǤʴѴԤ
׵ѥå(Type 5)
	i16	ƥֹ
	u16	Хåե
	i32	⡼
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
??? ɤ褦 IME_SMODE_AUTOMATICˤɤ߲̾򥻥åȤƤⲿⵯʤ
  ImmNotifyIME()ѴǤ뤬Ǥ̤ϢʸѴѤʤ
  饤ȤƤɤ߲̾޻ᤷϤȤime뤳Ȥˤ롣
  Ϥޤ⤦äȤޤˡϤʤ
*/
bool AutoConv(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t bufsize;
    int32_t mode;
    HIMC imc;
    char st=-1;

    Req5(ch,&cxn,&bufsize,&mode);
    DEBUGLOG(CH_CANNA,"context %hd, bufsize %hd, mode 0x%x\n",cxn,bufsize,mode);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
#ifdef SETCONTEXT_FAIL
	SetCurrentImc(imc,TRUE);
#else
	ImmSetOpenStatus(imc,TRUE);
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
#endif
	ImmSetConversionStatus(imc,CONV_MODE,IME_SMODE_AUTOMATIC);
	ImmReleaseContext(cx->Win,imc);
	cx->FerMode = mode;
	cx->YomiBufStart = cx->ConvertedCl = 0;
	st=0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*0x20  ĥץȥ䤤碌
׵ѥå(Type 17)
	s8	ꥯ̾ꥹ  'ꥯ̾@...@ꥯ̾@@'
ѥå(Type 2)
	i8	ץȥֹε1 顼:1
  ꥯ̾ꥹȤˤϡ1 ĤγĥʤϢΥꥯȤ̾ꤹ롣Ф
  ֤ͤϡγĥκǽΥꥯȤֹ椫 1 򸺤ΤǤ롣ĥץȥ
  Ĥʤ硢1 ֤롣
*/
bool QueryExt(CanHeader* ch,int fd UNUSED)
{
    static const char* extnames[]={
	"GetServerInfo\0"	"GetAccessControlList\0"
	"CreateDictionary\0"	"DeleteDictionary\0"
	"RenameDictionary\0"	"GetWordTextDictionary\0"
	"ListDictionary\0"	"Sync\0"
	"ChmodDictionary\0"	"CopyDictionary\0",

	//so/pkt.hΥץȥֹ,main.cinit_cb()ѹ뤳
	"WimeOpenIMEDialog\0"
	"WimeSetCompWin\0"
	"WimeGetCompWin\0"
	"WimeSendKey\0"
	"WimeEnableIme\0"
	"WimeMoveShadowWin\0"
	"WimeSetCompFont\0"
	"WimeGetCompStr\0"
	"WimeSetCandWin\0"
	"WimeRegXWindow\0"
	"WimeGetResultStr\0"
	"WimeSetResultStr\0"
	"WimeReconvert\0"
	"WimeSetFocus\0"
	"WimeShowToolbar\0"
	"WimeGetStyleList\0"
	"WimeReset\0"
	"WimeFlushMsg\0"
	"WimeShowCandWin\0"
	"WimeSelectCand\0"
	"WimeCloseCandWin\0"
	"WimeDumpContext\0"
	"WimeSetDebugChannel\0"
	"WimeGetColor\0"
	"WimeGetCandWin\0"
	"WimeCandIndex\0"
    };

    int id;
    Array names,reqs;
    char* reqnames = ((Req17_t*)ch)->p1;
    ArNew(&names,1,NULL);
    ArNew(&reqs,1,NULL);
    for(int ext=0; ext<2; ++ext){
	ListRaw(ArClear(&names),extnames[ext]);
	ListRaw(ArClear(&reqs),reqnames);
	if((id = SubList(&names,&reqs)) >= 0)
	    break;
	/*֤Τϥꥹΰ֤ʤΤǣץȥֹȤƤϣǡQueryExt
	  {ץȥֹ-1}֤Τǥꥹֹ򤽤Τޤ֤
	 */
    }
    ArDelete(&names);
    ArDelete(&reqs);
    return Reply2(ch->Major,ch->Minor,(char)id);
}

/*21  ץꥱ̾Ͽ:饤ȤΥץꥱ̾򤽤ΥФΤϿ롥
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	ץꥱ̾  'ץꥱ̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
??? ⡼ɤȥƥȤϤɤäȤ˻Ȥ
  ƥȤꤵȤȤϡƥȤȤ˥ץ̾ꤵȤȡ
*/
bool SetAppName(CanHeader* ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char* name = Req15(ch,&mode,&cxn);
    DEBUGLOG(CH_CANNA,"mode %d, context %hd, name %s, IGNORE mode and context\n",mode,cxn,name);
    ClientData_t* cdt = FindClient(fd);
    free(cdt->App);
    cdt->App = strdup(name);
    return Reply2(ch->Major,ch->Minor,0);
}

/*22  롼̾:饤ȤΥ롼̾򥵡ФΤϿ롣
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	롼̾  '롼̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 
*/
bool NoticeGroup(CanHeader* ch,int fd)
{
    int32_t mode;
    int16_t cxn;
    char* name = Req15(ch,&mode,&cxn);
    DEBUGLOG(CH_CANNA,"mode %d, context %hd, group %s, IGNORE mode and context\n",mode,cxn,name);
    ClientData_t* cdt = FindClient(fd);
    free(cdt->Group);
    cdt->Group = strdup(name);
    return Reply2(ch->Major,ch->Minor,0);
}

/*24  Фλ
׵ѥå(Type 1)
ѥå(Type 2)
	i8	ơ  : 0 / 顼: 
ߡ顼ͤȤƤΤϡʲ̤Ǥ롣
OLDSRV ؤʡVersion 3.2 ΥФ˥ץȥä
NOTUXSRV ФưƤޥ󤫤ץȥ뤬Ƥʤ
NOTOWSRV Фư桼̾ȰפƤʤ
!!! 顼ν򤷤Ƥʤ
*/
bool KillServer(CanHeader* ch,int fd UNUSED)
{
    DEBUGLOG(CH_CANNA,"kill wime\n");
    Reply2(ch->Major,ch->Minor,0);
    ImCloseAll();
    PostQuitMessage(0);
    return true;
}

/*1-01 о:Ф³Ƥ륯饤ȿʤɤΥо롥
׵ѥå(Type 1)
ѥå(Type 1)
	u8	λ(0)
	u8	᥸㡼ХС
	u8	ޥʡХС
	u32	ФưƤޥθ߻  ctime
	u16	ץȥ  ǧǤץȥο
	u16	ץȥ̾ꥹĹ(2ХȤcard8ȤʤäƤ뤬16bitδְ㤤)
	s8	ץȥ̾ꥹ  'ʸ@ʸ@...@@'
	u32[]	ץȥ  {4ߥץȥ}Х
	u16	³Ƥ륯饤ȿ
	u16	ƥȿ
	u16	饤ȾꥹĹ
	i8[]	饤Ⱦꥹ  (Ĺ+) η֤
ƥ饤Ȥξϰʲ̤Ǥ롥
	i32	åֹ
	i32	桼ֹ
	u32	桼  ñ
	u32	ɥ  ñ
	u32	ͥȻ  ñ
	u32[]	ץȥ  {4ߥץȥ}Х
	u16	桼̾Ĺ
	s8	桼̾  2Хȶ˹礦褦ѥǥ󥰤롥
	u16	ۥ̾Ĺ  2ХȤcard8ȤʤäƤ뤬16bitδְ㤤
	s8	ۥ̾  2Хȶ˹礦褦ѥǥ󥰤롥
	s8	饤̾
	u8[]	ƥȴե饰
*/
bool GetServerInfo(CanHeader* ch,int fd UNUSED)
{
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-02 лѵ:ФλѵĤλȤԤ
׵ѥå(Type 1)
ѥå(Type 6)
	i16	ۥȿ  顼: 1
	s8	ۥ̾ꥹ  'ۥ̾@桼̾@...@桼̾@@ۥ̾@桼̾@...@@'
*/
bool GetAcl(CanHeader* ch,int fd UNUSED)
{
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    return Reply5(ch->Major,ch->Minor,-1);
}

/*1-03 :ƥȼ dics.dir Ƥ򹹿롥
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾  '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
*/
bool CreateDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* dic = Req15(ch,&mode,&cxn);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, dic %s\n",cxn,mode,dic);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-04  :ƥȼ dics.dir Ƥ򹹿롥
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾  '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
*/
bool DeleteDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* dic = Req15(ch,&mode,&cxn);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, dic %s\n",cxn,mode,dic);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-05 ̾ѹ:桼μ̾ѹ롥
׵ѥå(Type 16)
	i32	⡼
	i16	ƥֹ
	s8	ߤμ̾  '̾@'
	s8	̾  '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 1
Req16ȤʤäƤ뤬Req19(QueryDic)Ȥ롣ȤQueryDicְäƤΤ
*/
bool RenameDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* cur_dic;
    char* new_dic = Req19(ch,&mode,&cxn,&cur_dic);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, current-dic %s, new-dic %s\n",cxn,mode,cur_dic,new_dic);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-06 ñ:ƥȼñ롥
׵ѥå(Type 18)
	i16	ƥֹ
	s8	ǥ쥯ȥ̾ 'ǥ쥯ȥ̾@'
	s8	̾ '̾@'
	u16	Хåե
ѥå(Type 7)
	i16	ñĹ  顼: 1
	s16	ʸꥹ 'ʸ@@'
*/
bool GetWordTextDic(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    char *dir,*dic;

    uint16_t bufsize = Req18((Req18_t*)ch,&cxn,&dir,&dic);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, directory %s, dic %s, bufsize %hu\n",cxn,dir,dic,bufsize);
    return Reply5(ch->Major,ch->Minor,-1);
}

/*1-07 ơ֥:ꤷǥ쥯ȥˤ뼭ơ֥롥
׵ѥå(Type 18)
	i16	ƥֹ
	s8	ǥ쥯ȥ̾ 'ǥ쥯ȥ̾[:ǥ쥯ȥ̾]..'
	u16	Хåե
ѥå(Type 6)
	i8	  顼: 1
	s8	ꥹ '̾@...@̾@@'
ɥȤǤ׵᥿18ˤʤäƤ뤬18 i16,s8,s8,u16
Υץȥ륿 i16,s8,u16 򥿥16ˤ롣
*/
bool ListDic(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    char* dirs;
    uint16_t bufsize = Req16((Req16_t*)ch,&cxn,&dirs);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, bufsize %hu, dir %s\n",cxn,bufsize,dirs);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-08 ꥽ι:ݻƤ뼭򼭽˽񤭹ࡥ
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 
*/
bool Sync(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* dic = Req15(ch,&mode,&cxn);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, dic %s\n",cxn,mode,dic);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*1-09 READ/WRITE ѹ
׵ѥå(Type 15)
	i32	⡼
	i16	ƥֹ
	s8	̾ '̾@'
ѥå(Type 5)
	i16	λ  : chmoddic / 顼: 
*/
bool ChmodDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char* dic = Req15(ch,&mode,&cxn);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, dic %s\n",cxn,mode,dic);
    return Reply5(ch->Major,ch->Minor,-1);
}

/*1-0a ʣ
׵ѥå(Type 21)
	i32	⡼
	i16	ƥֹ
	s8	ʣ̸Υǥ쥯ȥ̾ 'ǥ쥯ȥ̾@'
	s8	ʣ̸μ̾ '̾@'
	s8	ʣμ̾ '̾@'
ѥå(Type 2)
	i8	λ  : 0 / 顼: 
*/
bool CopyDic(CanHeader* ch,int fd UNUSED)
{
    int32_t mode;
    int16_t cxn;
    char *dir,*src;

    char* dst = Req21(ch,&mode,&cxn,&dir,&src);
    ERRORLOG(CH_GLOBAL,"*** NOT IMPLIMENT ***\n");
    DEBUGLOG(CH_CANNA,"context %hd, mode %d, dir %s, source %s, destination %s\n",cxn,mode,dir,src,dst);
    return Reply2(ch->Major,ch->Minor,-1);
}

/*
  ׵ᡧtype2
	i16  ܥåμ
		0=ץѥƥ
		1=ñ졿Ͽ
		2=桼
  type2
	i8   顼λ=-1

  ??? IME_CONFIG_REGISTERWORDԤΤϤʤ
*/
bool OpenDialog(CanHeader* ch,int fd UNUSED)
{
    unsigned modes[]={IME_CONFIG_GENERAL,IME_CONFIG_REGISTERWORD,IME_CONFIG_SELECTDICTIONARY};
    char st=-1;
    int16_t dialog_type = Req2(ch);

    DEBUGLOG(CH_CANNA,"dialog type code %hu\n",dialog_type);

    //ImmConfigureIMEhwndϥХ륳ƥȤΤΤȤȤˤ롣
    REGISTERWORDA reg = {.lpReading=NULL, .lpWord=NULL};
    CannaContext_t* cx = ArElem(&Context,0);

    if(dialog_type<3 && ImmConfigureIME(GetKeyboardLayout(0),cx->Win,modes[dialog_type],&reg)){
	st = 0;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

#ifdef DEBUG_MODE
int get_mod_name(void* buf,int bufsize,void* data/* LONG* */)
{
    sz = GetModuleFileName((HMODULE)*(LONG*)data,buf,bufsize);
    return sz<bufsize ? 0 : sz;
}
int get_cl_name(void* buf,int bufsize,void* data/* HWND* */)
{
    sz = GetClassName(*(HWND*)data,buf,bufsize);
    return sz<bufsize ? 0 : sz;
}

//lp=intκѿΥɥ쥹,ͣ
BOOL CALLBACK EnumWin(HWND h,LPARAM lp)
{
    int st,*counter=(int*)lp;
    LONG wl[][2]={{GWL_EXSTYLE,0},{GWL_STYLE,0},{GWL_WNDPROC,0},{GWL_HINSTANCE,0},{GWL_HWNDPARENT,0},{GWL_ID,0},{GWL_USERDATA,0}};
    DWORD cl[][2]={{GCW_ATOM,0},{GCL_HMODULE,0},{GCL_MENUNAME,0}};

    if((*counter)++ == 0)
	MESG("hwnd	class	exstyle	style	wndproc	instance	parent	id	userdata	atom	module	menu\n");

    for(st=0; st<7; ++st)
        wl[st][1] = GetWindowLong(h,wl[st][0]);
    for(st=0; st<3; ++st)
        cl[st][1] = GetClassLong(h,cl[st][0]);

    ArNew(&buf,1,NULL);
    ArBuf(&buf,get_cl_name,&h);
    MESG("%x\t%s\t",(unsigned)h,(char*)ArAdr(&buf));
    MESG("%x\t%x\t",wl[0][1],wl[1][1]); //exstyle,style
    MESG("%x\t",wl[2][1]); //wndproc
    ArBuf(&buf,get_mod_name,&(wl[3][1]));
    MESG("%x(%s)\t%x\t",wl[3][1],(char*)ArAdr(&buf),wl[4][1]); //instance,parent
    MESG("%x\t%x\t",wl[5][1],wl[6][1]); //id,userdata
    ArBuf(&buf,get_mod_name,&(LONG)(cl[1][1]));
    MESG("%x\t%x(%s)\t%x\n",cl[0][1],cl[1][1],(char*)ArAdr(&buf),cl[2][1]); //atom,module,menu
    ArDelete(&buf);
    return TRUE;
}

void debug_window(HWND w)
{
    int dum=0;
    MESG("window listing...\n");
    EnumWindows(EnumWin,(LPARAM)&dum);
    MESG("...end,%d windows\n",dum);

    COMPOSITIONFORM cf;
    HIMC imc=ImmGetContext(w);
    ImmGetCompositionWindow(imc,&cf);
    ImmReleaseContext(w,imc);
    switch(cf.dwStyle){
    case CFS_DEFAULT:
	MESG("comp-form:default\n");
	break;
    case CFS_FORCE_POSITION:
	MESG("comp_form:force %d %d\n",cf.ptCurrentPos.x,cf.ptCurrentPos.y);
	break;
    case CFS_POINT:
	MESG("comp_form:point %d %d\n",cf.ptCurrentPos.x,cf.ptCurrentPos.y);
	break;
    case CFS_RECT:
	MESG("comp_form:rect %d %d %d %d\n",cf.rcArea.left,cf.rcArea.top,cf.rcArea.right,cf.rcArea.bottom);
	break;
    default:
	MESG("comp_form:??? (%x)\n",cf.dwStyle);
    }

    MESG("fg window:%x exist:%d visible:%d\n",(unsigned)GetForegroundWindow(),IsWindow(w),IsWindowVisible(w));
    MESG("fg window info...\n");
    dum=0;
    EnumWin(GetForegroundWindow(),(LPARAM)&dum);
    MESG("...end\n");
}
#endif

/*
  ImmSetCompositionWindow
  ׵ᡧtype11
	i16=ƥֹ
	i16=style
	s16=WIME_POS_DEFAULT:ʤ
	    WIME_POS_{FORCE,POINT}:x,y
	    WIME_POS_RECT:x,y,w,h   windowsȤϰ㤦Τ
  type2
	bool
*/
bool SetCompWin(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,style;
    HIMC imc;
    bool st=false;

    uint16_t* params = Req11(ch,&cxn,&style);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	COMPOSITIONFORM cf;
	switch(style){
	case WIME_POS_DEFAULT:
	    cf.dwStyle = CFS_DEFAULT;
	    break;
	case WIME_POS_FORCE:
	    cf.dwStyle = CFS_FORCE_POSITION;
	    break;
	case WIME_POS_POINT:
	    cf.dwStyle = CFS_POINT;
	    break;
	case WIME_POS_RECT:
	    cf.dwStyle = CFS_RECT;
	}

	switch(style){
	case WIME_POS_FORCE:
	case WIME_POS_POINT:
	    cf.ptCurrentPos.x = params[0];
	    cf.ptCurrentPos.y = params[1];
	    DEBUGLOG(CH_CANNA,"context %hd, pos (%hd,%hd)\n",cxn,params[0],params[1]);
	    break;
	case WIME_POS_RECT:
	    cf.rcArea.left = params[0];
	    cf.rcArea.top = params[1];
	    cf.rcArea.right = params[0]+params[2];
	    cf.rcArea.bottom = params[1]+params[3];
	    //RECTΥإפǤ(r,b)ϻͳѤ˴ޤޤʤ
	    DEBUGLOG(CH_CANNA,"context %hd, rect (%d,%d)-(%d,%d)\n",cxn,cf.rcArea.left,cf.rcArea.top,cf.rcArea.right,cf.rcArea.bottom);
	}
	st = ImmSetCompositionWindow(imc,&cf);
	ImmReleaseContext(cx->Win,imc);
	DEBUGLOG(CH_CANNA,"context %hd, wnd %p, ret %d\n",cxn,cx->Win,st);
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/* Ѵ⡼ɤ֤
   imcNULLΤȤϥǥեȤ֤
 */
unsigned conv_mode(HIMC imc)
{
    bool default_status = false;
    if(!imc){
	imc = ImmCreateContext();
	default_status = true;
    }
    DWORD c,s;
    if(!ImmGetConversionStatus(imc,&c,&s)){
	c = CONV_MODE;
	DEBUGLOG(CH_CANNA,"fail ImmGetConversionStatus,force CONV_MODE.\n");
    }
    DEBUGLOG(CH_CANNA,"roman mode=%d\n",((c & IME_CMODE_ROMAN)!=0));
    if(default_status){
	ImmDestroyContext(imc);
    }
    return c;
}

#include <X11/X.h>
#include <X11/keysym.h>
static int KeyMap[][2]={
    {XK_yen,VK_OEM_5},		/* | */
    {XK_BackSpace,VK_BACK},	/* Back space, back char */
    {XK_Tab,VK_TAB},
    {XK_Clear,VK_CLEAR},
    {XK_Return,VK_RETURN},	/* Return, enter */
    {XK_Pause,VK_PAUSE},	/* Pause, hold */
    {XK_Escape,VK_ESCAPE},
    {XK_Delete,VK_DELETE},	/* Delete, rubout */
    {XK_Home,VK_HOME},
    {XK_Left,VK_LEFT},		/* Move left, left arrow */
    {XK_Up,VK_UP},		/* Move up, up arrow */
    {XK_Right,VK_RIGHT},	/* Move right, right arrow */
    {XK_Down,VK_DOWN},		/* Move down, down arrow */
    {XK_Page_Up,VK_PRIOR},
    {XK_Page_Down,VK_NEXT},
    {XK_End,VK_END},		/* EOL */
    {XK_Begin,VK_HOME},		/* BOL */
    {XK_Select,VK_SELECT},	/* Select, mark */
    {XK_Print,VK_PRINT},
    {XK_Execute,VK_EXECUTE},	/* Execute, run, do */
    {XK_Insert,VK_INSERT},	/* Insert, insert here */
    {XK_Menu,VK_MENU},
    {XK_Cancel,VK_CANCEL},	/* Cancel, stop, abort, exit */
    {XK_Help,VK_HELP},		/* Help */
    {XK_Num_Lock,VK_NUMLOCK},
    {XK_KP_Multiply,VK_MULTIPLY},
    {XK_KP_Add,VK_ADD},
    {XK_KP_Separator,VK_SEPARATOR},	/* Separator, often comma */
    {XK_KP_Subtract,VK_SUBTRACT},
    {XK_KP_Decimal,VK_DECIMAL},
    {XK_KP_Divide,VK_DIVIDE},
    {XK_KP_0,VK_NUMPAD0},
    {XK_KP_1,VK_NUMPAD1},
    {XK_KP_2,VK_NUMPAD2},
    {XK_KP_3,VK_NUMPAD3},
    {XK_KP_4,VK_NUMPAD4},
    {XK_KP_5,VK_NUMPAD5},
    {XK_KP_6,VK_NUMPAD6},
    {XK_KP_7,VK_NUMPAD7},
    {XK_KP_8,VK_NUMPAD8},
    {XK_KP_9,VK_NUMPAD9},
    {XK_F1,VK_F1},
    {XK_F2,VK_F2},
    {XK_F3,VK_F3},
    {XK_F4,VK_F4},
    {XK_F5,VK_F5},
    {XK_F6,VK_F6},
    {XK_F7,VK_F7},
    {XK_F8,VK_F8},
    {XK_F9,VK_F9},
    {XK_F10,VK_F10},
    {XK_F11,VK_F11},
    {XK_F12,VK_F12},
    {XK_F13,VK_F13},
    {XK_F14,VK_F14},
    {XK_F15,VK_F15},
    {XK_F16,VK_F16},
    {XK_F17,VK_F17},
    {XK_F18,VK_F18},
    {XK_F19,VK_F19},
    {XK_F20,VK_F20},
    {XK_F21,VK_F21},
    {XK_F22,VK_F22},
    {XK_F23,VK_F23},
    {XK_F24,VK_F24},
    {XK_Shift_L,VK_SHIFT},	/* Left shift */
    {XK_Shift_R,VK_SHIFT},	/* Right shift */
    {XK_Control_L,VK_CONTROL},	/* Left control */
    {XK_Control_R,VK_CONTROL},	/* Right control */
    {XK_Caps_Lock,VK_CAPITAL},	/* Caps lock */
    {XK_Eisu_toggle,VK_OEM_ATTN}, /*ѿ*/
    {XK_Alt_L,VK_MENU},		/* Left alt */
    {XK_Alt_R,VK_MENU},		/* Right alt */
    {XK_Super_L,VK_LWIN},	/* Left super */
    {XK_Super_R,VK_RWIN},	/* Right super */
    {XK_Zenkaku_Hankaku,VK_OEM_AUTO},	/*Ⱦ/*/
    {XK_Muhenkan,VK_NONCONVERT},	/*̵Ѵ*/
    {XK_Henkan_Mode,VK_CONVERT},	/*Ѵ*/
    {XK_Hiragana_Katakana,VK_OEM_COPY},	/* Ҥ餬*/
    {XK_Kanji,VK_KANJI},		/*Alt+Ⱦ/*/
    {XK_Romaji,VK_OEM_BACKTAB},		/*Alt+ʤҤ餬*/
    {XK_VoidSymbol,0}
};

static uint8_t* Xk2Vk[256];//vk8bit󡣳Ǥϲ8bit󡣤ѿʳ

 __attribute__((constructor))
void initkeymap(void)
{
    for(int n=0; KeyMap[n][0]!=XK_VoidSymbol; ++n){
	uint8_t** p = Xk2Vk + (KeyMap[n][0]>>8);
	if(*p == NULL)
	    *p = calloc(256,1);
	*(*p + (KeyMap[n][0] & 0xff)) = KeyMap[n][1];
    }
}

/*
  Xkeysymwinβۥɤˤ롣8ӥåȤˤϽξ֤롣
  keysym1=group2keysymʥ⡼ɤλȤ
*/
unsigned xk_to_vk(unsigned keysym0,unsigned keysym1,unsigned state,HKL kl,unsigned convmode)
{
    unsigned vk=0;
    unsigned keysym = ((convmode & IME_CMODE_ROMAN)!=0 || keysym1==0) ? keysym0 : keysym1;
    unsigned up = keysym>>8;
    
    
    if(up<=0xff && Xk2Vk[up]!=NULL)
	vk = Xk2Vk[up][keysym & 0xff]; //Ѥkeysym
    if(vk == 0){
	//ʤkeysymǤunicodeľ
	if(keysym>=XK_kana_fullstop && keysym<=XK_semivoicedsound)
	    keysym = keysym-XK_kana_fullstop+0xff61; //keysymunicode
	vk = VkKeyScanExW(keysym,kl);
    }
    if(state & ShiftMask)
	vk |= VKMODKEY(WINMODKEY_SHIFT);
    if(state & ControlMask)
	vk |= VKMODKEY(WINMODKEY_CTRL);
    if(state & Mod1Mask)
	vk |= VKMODKEY(WINMODKEY_ALT);
    if(state & LockMask)
	vk |= VKMODKEY(WINMODKEY_LOCK);
    DEBUGLOG(CH_CANNA,"keysym 0x%x/0x%x-0x%x --> vk 0x%x\n",keysym0,keysym1,state,vk);
    return vk;
}

/*
  ׵ᡧtype64
	[0]=ƥֹ
	[1]=keysym(group1)
	[2]=keysym(group2)
	[3]=Xνξ
  type6
	i16=WIME_SENDKEY_XXX
	s8=ime˽줿Ȥγʸ(utf8)()
*/
bool SendKey(CanHeader* ch,int fd UNUSED)
{
    int32_t* p = (typeof(p))(ch+1);
    int16_t st=WIME_SENDKEY_ERROR;
    char* u8 = NULL;
    HIMC imc;
#define CXN p[0]
#define KEYSYM0 p[1]
#define KEYSYM1 p[2]
#define KEYSTATE p[3]
    
    CannaContext_t* cx = GetContext(CXN,&imc,__FUNCTION__);
    if(cx != NULL){
	HKL kl = GetKeyboardLayout(0);
	unsigned convmode = conv_mode(imc);
	uint16_t vk = xk_to_vk(KEYSYM0,KEYSYM1,KEYSTATE,kl,convmode);

	/*޻/ʤڤؤImmProcessKeyǤSendInputǤǤʤΤǡImmSetConversionStatus
	 ѹ롣*/
	if((vk & 0xff)==VK_OEM_BACKTAB){
	    convmode ^= IME_CMODE_ROMAN;
	    ImmSetConversionStatus(imc,convmode,IME_SMODE_PHRASEPREDICT);
	    st=WIME_SENDKEY_SUCCESS; //[r268]
	}
	
	/*[r14]θ塢ѴǤϤʤΤWM_IME_NOTIFY,IMN_OPENCANDIDATEǤȤ롣
	  طʤȤWIME_SENDKEY_OPENCAND֤ƤޤΤǡ˥ե饰򥯥ꥢƤ*/
	cx->Flags &= ~(CATCH_OPEN_CAND|CATCH_CHG_CAND|CATCH_FINISH);
	
	if(st==WIME_SENDKEY_SUCCESS || proc_key_vk(vk,cx->Win,kl,convmode)){ //[r268]
	    st = WIME_SENDKEY_SUCCESS;
	    cx->Flags |= SEND_KEY; //wnd_proc()
	    Array u16;
	    ClauseStr(imc,cx,GCS_RESULTSTR,0,-1,ArNew(&u16,2,NULL),false);
	    u8 = U16ToU8(NULL,NULL,ArAdr(&u16),-1);
	    ArDelete(&u16);
	    DEBUGDO(CH_CANNA,DbgComp(imc,__func__));
	}else
	    st = WIME_SENDKEY_NO_PROC;

	/*???
	  Ѵλ,δؿWM_IME_REQUEST롣
	  proc_key_vk()ImmProcessKey()ǥå롼פ󤵤褦
	  proc_key_vk()̤ä̤ʤä褯ʬʤΤǡȤˤu8ϲ롣
	*/
	if(cx->Flags & PENDING_RECONV){
	    st = WIME_SENDKEY_RECONV;
	    cx->Flags &= ~PENDING_RECONV;
	    free(u8);
	    u8 = NULL;
	    DEBUGLOG(CH_CANNA,"reconvertion --> pending\n");
	}

	/*[r11]WM_IME_NOTIFY,IMN_OPENCANDIDATEϤδؿǤϵ餺˥å롼פä
	  Ȥ˽ߤCATCH_OPEN_CANDåȤΤϤΤȤˤʤΤǡ䥦ɥ
	  ɽ줿狼ΤϼθƤӽФλˤʤäƤޤǤ1;פѴ򲡤Ȥˤ
	  ΤǡWM_IME_NOTIFY롣*/
	cx->Flags &= ~(CATCH_OPEN_CAND|CATCH_CHG_CAND);
	flush_msg_loop();
	/* ɥץWM_IME_NOTIFY,IMN_OPENCANDIDATECATCH_OPEN_CANDåȤ롣
	   Υե饰GetCandiList()Ǿä */
	if(cx->Flags & CATCH_OPEN_CAND){
	    st = WIME_SENDKEY_OPENCAND;
	}
	if(cx->Flags & CATCH_CHG_CAND){
	    st = WIME_SENDKEY_CHGCAND;
	    cx->Flags &= ~CATCH_CHG_CAND; //ϤǾäƤʤ
	}

	/*'Ѵ''̵Ѵ'򲡤ϥ⡼ɤѤȥime˽뤬imcƤϤΤޤޡ
	  ⤻ˤresult-str֤Ƥޤå롼פ
	  WM_IME_NOTIFY/IMN_SETCONVERSIONMODE뤬shift򲡤ʤϤȤΰѿ⡼
	  Ǥ⤳Υå롣ѿ⡼ɤǤcomp-str˥ǡ뤬'Ѵ'򲡤Ȥ
	  comp-str϶ʤΤǤΤȤresult-str֤ʤ褦ˤ롣
	  ѿ⡼ɤǳꤷȤȶ̤ĤʤΤǡWM_IME_COMPOSITIONGCS_RESULT...
	  å롣
	*/
	if((cx->Flags & CATCH_FINISH)==0 && ImcClauseInfo(imc,GCS_COMPSTR,NULL)<0){
	    free(u8);
	    u8 = NULL;
	    DEBUGLOG(CH_CANNA,"catch composition-finish\n");
	}

	ImmReleaseContext(cx->Win,imc);
	DEBUGLOG(CH_CANNA,"context %d, wnd %p, vk 0x%hx --> proc_key status %hd\n",CXN,cx->Win,vk,st);
    }
    bool rep_st = Reply6s(ch->Major,ch->Minor,st,u8);
    free(u8);
    return rep_st;

#undef CXN
#undef KEYSYM0
#undef KEYSYM1
#undef KEYSTATE
}

/*
  Ѵ䥦ɥɽ/ɽ
  ׵ᡧtype3
	i16=ƥֹ
	u16=bool
  type2 true
  ɽʤ褦ˤȤϡWimeSendKey()Ǹ䥦ɥɽ褦ȤȤWIME_SENDKEY_OPENCAND֤ΤǡGetCandiList()Ѵ뤳ȡ

  䥦ɥɽȤ˥ɥץWM_IME_NOTIFY,IMN_OPENCANDIDATEΤǡ
  줬cx->FlagsCATCH_OPEN_CAND򥻥åȤ롣
 */
bool ShowCandWin(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    uint16_t en;
    bool st=false;
    Req3(ch,&cxn,&en);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx != NULL){
	if(en)
	    cx->Flags &= ~TRAP_OPEN_CAND;
	else
	    cx->Flags |= TRAP_OPEN_CAND;
	st=true;
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*
  Ѵ
  ׵ᡧtype11
	i16=ƥֹ
	i16=ѴʸΥ֡ʸñ̡
	s16=Ѵ˻Ȥʸ(u16)
  type4
	i8=bool
	i32[0]=оʬγϰ(ʸñ)
	i32[1]=оʬĹʸñ̡
 */
bool Reconvert(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,cursor;
    HIMC imc;
    int32_t info[2]={0,0};
    bool st=false;

    uint16_t* reconv = Req11(ch,&cxn,&cursor);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	DEBUGLOG(CH_CANNA,"cursor %hd, string '%W'\n",cursor,reconv);
	unsigned sz = (WcLen(reconv)+1)*2;
	unsigned bufsize = sizeof(RECONVERTSTRING)+sz;
	RECONVERTSTRING* rs = calloc(bufsize,1);
	memcpy(rs+1,reconv,sz);
	rs->dwStrLen = sz-2;	//̥ʸϽ
	rs->dwStrOffset = sizeof(*rs);
	rs->dwTargetStrOffset = cursor*2;	//Хñ
	st = ImmSetCompositionStringW(imc,SCS_QUERYRECONVERTSTRING,rs,bufsize,NULL,0) && ImmSetCompositionStringW(imc,SCS_SETRECONVERTSTRING,rs,bufsize,NULL,0);
	info[0] = rs->dwCompStrOffset/2;	//??? atok08ǤϥХȿߤ
	info[1] = rs->dwCompStrLen;		//??? äʸߤ

	DEBUGDO(CH_CANNA,{
		MESG("status %d, CompStrOffset %d, CompStrLen %d\n",st,rs->dwCompStrOffset,rs->dwCompStrLen);
		DbgComp(imc,__func__);});
	
	ImmReleaseContext(cx->Win,imc);
	free(rs);
    }
    return Reply4(ch->Major,ch->Minor,st,info,2);
}

/*
  imcıƥɥΰ֤礭ѹ
  (x,y),(w,h)줾Τɤ餫ǤлѤʤ
  s16ʸȤ(ХȥѤ)뤳
  ׵ᡧtype11
	i16=ƥֹ
	i16=unused
	s16[0,1]=(x,y)
	s16[2,3]=(w,h)
  type2
	bool
*/
bool MoveShadowWin(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,dum;
    bool st=false;

    int16_t* ax = (int16_t*)Req11(ch,&cxn,&dum);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx != NULL){
	unsigned flg = SWP_NOREDRAW; /*SWP_NOZORDER|SWP_HIDEWINDOW|*/
	if(ax[0]<0 || ax[1]<0)
	    flg |= SWP_NOMOVE;
	if(ax[2]<0 || ax[3]<0)
	    flg |= SWP_NOSIZE;
	st = SetWindowPos(cx->Win,HWND_TOP,ax[0],ax[1],ax[2],ax[3],flg);
	DEBUGLOG(CH_CANNA,"context %hd (%hd,%hd)-%hdx%hd --> status %d\n",cxn,ax[0],ax[1],ax[2],ax[3],st);
    }
    return Reply2(ch->Major,ch->Minor,st);
}

//xlfdΥ̾ͤˤ
//!!! mediumFW_NORMAL400ǤϤʤ500ˤʤäƤޤɤ롩
int weight_value(const char* w,unsigned wlen)
{
    struct{
	char *name;
	int value;
    } tab[]={
	{"thin",FW_THIN},{"extralight",FW_EXTRALIGHT}, {"ultraright",FW_ULTRALIGHT},{"light",FW_LIGHT},	{"normal",FW_NORMAL},{"regular",FW_REGULAR},{"medium",FW_MEDIUM},{"semibold",FW_SEMIBOLD}, {"demibold",FW_DEMIBOLD},{"bold",FW_BOLD},{"extrabold",FW_EXTRABOLD},{"ultrabold",FW_ULTRABOLD}, {"heavy",FW_HEAVY},{"black",FW_BLACK}
    };
    char wname[wlen+1];
    memcpy(wname,w,wlen);
    wname[wlen]=0;

    int v = FW_NORMAL;
    for(unsigned n=0; n<ITEMS(tab); ++n){
	if(strcasecmp(wname,tab[n].name)==0){
	    v=tab[n].value;
	    break;
	}
    }
    return v;
}

/*
  եȥåȤjisx0208LOGFONTꤹ롣
*/
bool fontset_to_logfont(LOGFONT* lf,const char* fs)
{
    char* pt[14]={NULL};
    char jx0208[]="jisx0208";
    bool st=false;

    *lf = (typeof(*lf)){0};
    lf->lfCharSet=SHIFTJIS_CHARSET;
    lf->lfOutPrecision=OUT_DEFAULT_PRECIS;
    lf->lfClipPrecision=CLIP_DEFAULT_PRECIS;
    lf->lfWeight = FW_NORMAL;

    while(fs != NULL){
	//xlfdǤƬɥ쥹pt[]
	for(int n=0; n<ITEMS(pt); ++n){
	    if((pt[n] = strchr(fs,'-'))==NULL || *(fs = ++pt[n])==0)
		break;
	}

	if(strncasecmp(pt[12],jx0208,sizeof(jx0208)-1) == 0){
	    size_t len = pt[2]-pt[0]-1;
	    memcpy(lf->lfFaceName,pt[0],len);
	    lf->lfFaceName[len] = 0;
	    lf->lfFaceName[pt[1]-pt[0]-1] = ' ';

	    if((lf->lfHeight = atoi(pt[6])) == 0)
		lf->lfHeight = 16; //!!! ʤȤʤ
	    lf->lfWeight = weight_value(pt[2],pt[3]-pt[2]-1);
	    if(*pt[3] == 'i')
		lf->lfItalic = TRUE;
	    st=true;
	    break;
	}

	fs = strchr(fs,',');
    }
    return st;
}

/*
  ѴɥΥեȤꤹ
  ׵ᡧtype15
	i32=طʿ
	i16=ƥֹ
	s8=եȥå
  type5
	i16=եȤι⤵顼λ0

  ??? طʿλϤɤ뤫
*/
bool SetCompFont(CanHeader* ch,int fd UNUSED)
{
    int16_t h=0,cxn;
    uint32_t bg;
    HIMC imc;

    ERRORLOG(CH_CANNA,"*** PARTIAL IMPLIMENT ***\n");
    char* fontname = Req15(ch,(int32_t*)&bg,&cxn);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	LOGFONT lf;

	DEBUGLOG(CH_CANNA,"fontset '%s'\n",fontname);
	if(fontset_to_logfont(&lf,fontname)){
	    DEBUGLOG(CH_CANNA,"alias name '%s', size %d, weight %d, italic=%d\n",lf.lfFaceName,lf.lfHeight,lf.lfWeight,lf.lfItalic);
	    if(!ImmSetCompositionFont(imc,&lf))
		ERRORLOG(CH_CANNA,"fail ImmSetCompositionFont()\n");
	}else
	    ERRORLOG(CH_CANNA,"fail fontset_to_logfont()\n");

	ImmGetCompositionFont(imc,&lf);
	h = abs(lf.lfHeight);
	DEBUGLOG(CH_CANNA,"facename '%s', height %d\n",lf.lfFaceName,lf.lfHeight);

	ImmReleaseContext(cx->Win,imc);
    }
    return Reply5(ch->Major,ch->Minor,h);
}

/*
  imeѤ
  ׵ᡧtype3
	i16	ƥֹ
	u16	bool(),뤤-1(䤤碌)
  type5
	i16	u16-1ΤȤߤξ(0/1),boolΤȤ1,顼λ-1
*/
bool EnableIme(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,st=-1;
    uint16_t en_ime;
    HIMC imc;

    Req3(ch,&cxn,&en_ime);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	if(en_ime == (uint16_t)-1){
	    st = ImmGetOpenStatus(imc);
	    DEBUGLOG(CH_CANNA,"context %hd, open status %hd\n",cxn,st);
	}else{
	    /*[3.4.3]
	      䥦ɥĤ(䥦ɥФƤ뤫ɤϥåƤʤ)
	      cx->ImeWndimcImmNotifyIMEǻȤäƤ⥦ɥĤSendMessageĤʤ
	      gtktreeåȤΥ饤ԽESC򲡤ե줿ꤷ硢
	      imwime_set_focus()ǥեȤˤʤäľimwime_finalize()ƤФ졢
	      䥦ɥФޤޤˤʤäƤޤ
	      imwime_finalize()ǥɥĤ?
	      ImmSetOpenStatus()falseˤʤȿƥȤĤäȤ˸䥦ɥ
	      褷Ƥޤ(Ȥ󤷤Ƥ뤻)
	    */
	    if(!en_ime)
		SendMessageW(cx->ImeWnd,WM_IME_NOTIFY,IMN_CLOSECANDIDATE,0);

	    st = ImmSetOpenStatus(imc,en_ime) ? 1 : -1;
	    DEBUGLOG(CH_CANNA,"context %hd, en_ime %hd, status %hd\n",cxn,en_ime,st);
	}
	ImmReleaseContext(cx->Win,imc);
    }
    return Reply5(ch->Major,ch->Minor,st);
}

//ġСȤäƤ̤ΥƥȤõ
static int another_tb_user(const void* elem,const void* val)
{
    const CannaContext_t* c = elem;
    return c->Win!=NULL && c->UseToolbar && c!=(CannaContext_t*)val;
}

void hide_toolbar(CannaContext_t* cx)
{
    //ġСȤäƤ̤ΥƥȤʤʤäġСɽˤ롣
    if(ArFindIf(&Context,0,another_tb_user,cx) < 0){
	SendMessageW(cx->Win,WM_IME_NOTIFY,IMN_CLOSESTATUSWINDOW,0);
    }
    cx->UseToolbar = false;
}

/*
  imeΥġСɽ
  ׵ᡧtype7
	i16	ƥֹ
	i16	bool ġСɽ
	i16	bool ѴɥȤ
  ̵
*/
bool ShowToolbar(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,show_tb,show_comp_win;
    HIMC imc;
    bool st=false;

    Req7(ch,&cxn,&show_tb,&show_comp_win);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	DEBUGLOG(CH_CANNA,"context %hd, use-tb %hd, use-cw %hd, ime-win %p\n",cxn,show_tb,show_comp_win,cx->ImeWnd);
	if(show_tb){
	    BringWindowToTop(cx->Win); //뤬ŤʤäƤȸ䥦ɥƤޤΤǰ־ˤ
	    cx->Flags &= ~PROC_COMP_MSG;
	    if(show_comp_win)
		cx->Flags |= PROC_COMP_MSG;
	    cx->Flags |= PROC_NOTIFY_MSG;
	    ImmSetConversionStatus(imc,conv_mode(NULL),IME_SMODE_PHRASEPREDICT);//ǥեȤѴ⡼ɤꤹ롣
	    SendMessageW(cx->Win,WM_IME_NOTIFY,IMN_OPENSTATUSWINDOW,0);
	    cx->UseToolbar = true;
	}else{
	    hide_toolbar(cx);//SendMessageW(cx->Win,WM_IME_NOTIFY,IMN_CLOSESTATUSWINDOW,0);
	    cx->Flags &= ~(PROC_COMP_MSG|PROC_NOTIFY_MSG);
	}
	ImmReleaseContext(cx->Win,imc);
	st = true;
    }
    return st;
}

/*
  եΰưΤ餻
  ׵:type64
	i32 p0	cxn
	i32 p1	bool(in=true,out=false)
  ʤ
*/
bool SetImeFocus(CanHeader* ch,int fd UNUSED)
{
    int32_t* p = (typeof(p))(ch+1);
    HIMC imc;
    bool st=false;
#define CXN p[0]
#define FOCUS_IN p[1]

    CannaContext_t* cx = GetContext(CXN,&imc,__FUNCTION__);
    if(cx != NULL){
	DEBUGLOG(CH_CANNA,"context %d, wnd %p, ime-wnd %p, imc %p, focus --> %s\n",CXN,cx->Win,cx->ImeWnd,imc,FOCUS_IN?"in":"out");
	if(FOCUS_IN){
	    ImmSetOpenStatus(imc,ImmGetOpenStatus(imc));
	    SetFocus(cx->Win);
	    CreateCaret(cx->Win,NULL,0,0);
	    cx->UseToolbar = true;
	}else{
	    DestroyCaret();
	    ImmSetOpenStatus(imc,ImmGetOpenStatus(imc));
	}
	ImmReleaseContext(cx->Win,imc);
	st = true;
    }
    return st;

#undef CXN
#undef FOCUS_IN
}

/*
  Ѵʸ
  ׵ᡧtype2
	i16=ƥֹ
  type64
	p1		顼=0,Ѵʸ󤬤=1,ʤ=-1
	databytes	sizeof(WimeCompStrInfo)
	bindata		WimeCompStrInfo
	str		Ѵʸ(utf8)
*/
bool GetCompStr(CanHeader* ch,int fd UNUSED)
{
    HIMC imc;
    WimeCompStrInfo si={.TargetClause=-1};
    int ret_code=0;
    char* cs_u8=NULL;
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	Array comp_str;
	ClauseStr(imc,cx,GCS_COMPSTR,0,-1,ArNew(&comp_str,2,NULL),false);
	int targetcl = si.TargetNum = GetAttrCl(imc,ATTR_TARGET_CONVERTED,cx);
	if(targetcl < 0)
	    targetcl = GetAttrCl(imc,ATTR_TARGET_NOTCONVERTED,cx);
	if(targetcl >= 0){
	    Array cl_info;
	    ImcClauseInfo(imc,GCS_COMPSTR,ArNew(&cl_info,4,NULL));
	    si.TargetClause = ARVAL(int32_t,&cl_info,targetcl);
	    si.TargetClLen = ARVAL(int32_t,&cl_info,targetcl+1) - si.TargetClause;
	    ArDelete(&cl_info);
	}
	si.Length = ArUsing(&comp_str)-1;
	
	//CursorPosDeltaStart
	INPUTCONTEXT* ic = ImmLockIMC(imc);
	COMPOSITIONSTRING* cs = ImmLockIMCC(ic->hCompStr);
	si.CursorPos = cs->dwCursorPos;
	si.DeltaStart = cs->dwDeltaStart;
	ImmUnlockIMCC(ic->hCompStr);
	ImmUnlockIMC(imc);

	ImmReleaseContext(cx->Win,imc);

	if(si.Length > 0){
	    cs_u8 = U16ToU8(NULL,NULL,ArAdr(&comp_str),-1);
	    ret_code = 1;
	    DEBUGLOG(CH_CANNA,"'%U' cursor %d delta %d target-cl %d cl-len %d len %d target# %d\n",cs_u8,si.CursorPos,si.DeltaStart,si.TargetClause,si.TargetClLen,si.Length,si.TargetNum);
	}else{
	    ret_code = -1;
	    DEBUGLOG(CH_CANNA,"(none)\n");
	}
	ArDelete(&comp_str);
    }

    bool st = Reply64(ch->Major,ch->Minor,ret_code,&si,sizeof(si),cs_u8,-1);
    free(cs_u8);
    return st;
}

/*
  Ѵɥξ
  ׵ᡧtype2
	i16=ƥֹ
  type4
	i8	顼=0
	i32[0]	(WIME_POS_xxx)
	i32[1]	x
	i32[2]	y
	i32[3]	w
	i32[4]	h

	Ȥʤɸǡ-1
*/
bool GetCompWin(CanHeader* ch,int fd UNUSED)
{
    HIMC imc;
    int32_t v[5]={-1};
    char st=0;
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	COMPOSITIONFORM cf;
	if(ImmGetCompositionWindow(imc,&cf)){
	    int32_t* vp = v;
	    st = 1;
	    switch(cf.dwStyle){
	    case CFS_DEFAULT:
		*vp = WIME_POS_DEFAULT;
		break;
	    case CFS_FORCE_POSITION:
		*vp = WIME_POS_FORCE;
		break;
	    case CFS_POINT:
		*vp = WIME_POS_POINT;
		break;
	    case CFS_RECT:
		*vp = WIME_POS_RECT;
	    }
	    ++vp;
	    switch(cf.dwStyle){
	    case CFS_FORCE_POSITION:
	    case CFS_POINT:
		*(vp++) = cf.ptCurrentPos.x;
		*(vp++) = cf.ptCurrentPos.y;
		break;
	    case CFS_RECT:
		*(vp++) = cf.rcArea.left;
		*(vp++) = cf.rcArea.top;
		*(vp++) = cf.rcArea.right - cf.rcArea.left;
		*(vp++) = cf.rcArea.bottom - cf.rcArea.top;
	    }
	    DEBUGLOG(CH_CANNA,"data [%#*.4D]\n",ITEMS(v),v);
	}else
	    ERRORLOG(CH_CANNA,"fail ImmGetCompositionWindow\n");
	ImmReleaseContext(cx->Win,imc);
    }
    return Reply4(ch->Major,ch->Minor,st,v,ITEMS(v));
}

/*
  ImmSetCandidateWindow
  ׵ᡧtype64
	[0]=ƥֹ
	[1]=style WIME_POS_DEFAULT,WIME_POS_POINT,WIME_POS_EXCLUDE
	[2,3]=x,y  (POINT,EXCLUDE)
	[4,5,6,7]=x,y,w,h (EXCLUDEr,bǤϤʤw,hǻꤹ)
  type2
	bool
  åȤΰưԤ
*/
bool SetCandWin(CanHeader* ch,int fd UNUSED)
{
    HIMC imc;
    bool st=false;
    int32_t* p = (typeof(p))(ch+1);
#define CXN p[0]
#define STYLE p[1]
#define POSX p[2]
#define POSY p[3]
#define EX p[4]
#define EY p[5]
#define EW p[6]
#define EH p[7]
    CannaContext_t* cx = GetContext(CXN,&imc,__FUNCTION__);
    if(cx != NULL){
	CANDIDATEFORM cf={.dwIndex=0,.dwStyle=CFS_DEFAULT};
	if(STYLE==WIME_POS_DEFAULT){
	    DEBUGLOG(CH_CANNA,"CFS_DEFAULT\n");
	}else{
	    cf.ptCurrentPos = (POINT){POSX,POSY};
	    DEBUGLOG(CH_CANNA,"pos (%d,%d)\n",cf.ptCurrentPos.x,cf.ptCurrentPos.y);
	    switch(STYLE){
	    case WIME_POS_POINT:
		cf.dwStyle = CFS_CANDIDATEPOS;
		break;
	    case WIME_POS_EXCLUDE:
		cf.dwStyle = CFS_EXCLUDE;
		cf.rcArea = (RECT){EX,EY, EX+EW-1,EY+EH-1};
		DEBUGLOG(CH_CANNA,"rect (%d,%d)-(%d,%d)\n",cf.rcArea.left,cf.rcArea.top,cf.rcArea.right,cf.rcArea.bottom);
	    }
	}
	st = ImmSetCandidateWindow(imc,&cf);
	ImmReleaseContext(cx->Win,imc);
	if(STYLE!=WIME_POS_DEFAULT)
	    SetCaretPos(cf.ptCurrentPos.x,cf.ptCurrentPos.y);
	DEBUGLOG(CH_CANNA,"context %d, wnd %p, ret %d\n",CXN,cx->Win,st);
    }
    return Reply2(ch->Major,ch->Minor,st);
#undef CXN
#undef STYLE
#undef POSX
#undef POSY
#undef EX
#undef EY
#undef EW
#undef EH
}

/*
  cannaƥȤXɥϢŤ롣Υɥ˲롣
  atokΥѥåȥġ뤫ϤλImAuxInput()ǻȤäƤ롣
  ׵:PktRegXWin
  :ʤ
*/
bool RegXWin(CanHeader* ch,int fd UNUSED)
{
    bool st=false;
    PktRegXWin* p = (typeof(p))(ch+1);
    CannaContext_t* cx = ValidContext(p->cxn,__FUNCTION__);
    if(cx != NULL){
	cx->XWin = p->xwin;
	st = true;
	DEBUGLOG(CH_CANNA,"context %d, window %x\n",p->cxn,p->xwin);
    }
    return st;
}

/*
  Ѵʸ롣
  ׵ᡧtype2
	i16	ƥֹ
  ʸ(u16le,̥ʸդ)
*/
bool GetResultStr(CanHeader* ch,int fd UNUSED)
{
    HIMC imc;
    Array str;

    ArNew(&str,2,NULL);
    CannaContext_t* cx = GetContext(Req2(ch),&imc,__FUNCTION__);
    if(cx != NULL){
	ClauseStr(imc,cx,GCS_RESULTSTR,0,-1,&str,false);
	ImmReleaseContext(cx->Win,imc);
	DEBUGLOG(CH_CANNA,"result str(u16)=%W\n",ArAdr(&str));
    }
    bool st = ReplyN(ch->Major,ch->Minor,ArAdr(&str),ArUsingBytes(&str));
    ArDelete(&str);
    return st;
}

/*
  ñϿ˻Ȥʻΰ
  ׵ᡧʤ
  type64
	p1		ǡο
	databytes	ΥХȿ(p1*sizeof(int))
	bindata		ɤ
	str		ʻ̾Υꥹ(utf8)
*/
bool GetStyleList(CanHeader* ch,int fd UNUSED)
{
    HKL kl = GetKeyboardLayout(0);
    int count = ImmGetRegisterWordStyleW(kl,0,NULL);
    STYLEBUFW* sty = calloc(sizeof(*sty),count);
    int* code = calloc(sizeof(int),count);
    Array desclist;
    ArNew(&desclist,1,NULL);
    ImmGetRegisterWordStyleW(kl,count,sty);

    DEBUGLOG(CH_CANNA,"%d items\n",count);
    for(int index=0; index<count; ++index){
	code[index] = sty[index].dwStyle;
	char* desc = U16ToU8(NULL,NULL,(uint16_t*)sty[index].szDescription,-1);
	ArAddStr(&desclist,desc);
	free(desc);
    }
    ArAddChar(&desclist,0);

    bool st = Reply64(ch->Major,ch->Minor,count,code,sizeof(int)*count,ArAdr(&desclist),ArUsing(&desclist));
    free(sty);
    free(code);
    ArDelete(&desclist);
    return st;
}

/*
  եɤ߹ߤ롣
  imcľ
  ׵ᡧʤ
  int	0=
  ??? 顼ɤǤ֤
*/
bool ReloadConf(CanHeader* ch,int fd UNUSED)
{
    int st = ImReadSetting(&WimeData);
    ReplaceWindow();
    DEBUGLOG(CH_CANNA,"reload setting file %d\n",st);
    return ReplyN(ch->Major,ch->Minor,&st,sizeof(st));
}

/*
  å롼פ
  ׵ᡧʤ
  int	0= 1=Ǥ
  imeǥå뤳Ȥ(SendKeyʤɤimeƤä)
  Υå˽λԤȡɥʤɤɽ줿ޤޤˤʤ뤳Ȥ롣
  λˤϤδؿƤǤ
  !!! ime offΥߥ󥰤ǼưŪ˸ƤӽФ褦ˤ٤ʽɽ˽Ф٤ǤϤʤ
*/
bool FlushMsg(CanHeader* ch,int fd UNUSED)
{
    int st = flush_msg_loop()?0:1;
    return ReplyN(ch->Major,ch->Minor,&st,sizeof(st));
}

/*
  Ѵ򤹤
  ׵ᡧtype3
	i16	ƥֹ
	u16	ֹ
  type2
	bool
  ??? ꥹȥڡֹϤɤ褦?
*/
bool SelectCand(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn;
    bool st=false;
    uint16_t index;
    HIMC imc;

    Req3(ch,&cxn,&index);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	DEBUGLOG(CH_CANNA,"context %hd, index %hd\n",cxn,index);
	if(ImmNotifyIME(imc,NI_SELECTCANDIDATESTR,0,index+WimeData.CandIndexStart)){
	    st=true;
	    DEBUGDO(CH_CANNA,DbgComp(imc,__func__));
	}
	ImmReleaseContext(cx->Win,imc);
    }
    return Reply2(ch->Major,ch->Minor,st);
}

/*
  Ѵ䥦ɥĤ롣
  SendKeyǼưŪ˳ɥĤ뤿˻Ȥ
  ??? showcloseset_cand_winˤޤȤƤޤäɤ?
  ׵ᡧtype2
	i16=ƥֹ
  :ʤ
*/
bool CloseCandWin(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = ValidContext(cxn,__FUNCTION__);
    if(cx != NULL){
	//wm_wime_enable_imeΥȻȡ
	SendMessageW(cx->ImeWnd,WM_IME_NOTIFY,IMN_CLOSECANDIDATE,0);
    }
    return true;
}

/*
  ʸϤȤ롣
  ׵ᡧtype11
	i16	ƥֹ
	i16	̤
	s16	ʸ(utf16)
  ʤ
*/
bool SetResultStr(CanHeader* ch,int fd UNUSED)
{
    int16_t cxn,dum;
    HIMC imc;
    bool st=false;

    uint16_t* extstr = Req11(ch,&cxn,&dum);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	DEBUGLOG(CH_CANNA,"context %hd, string '%W'\n",cxn,extstr);
#ifdef SETCONTEXT_FAIL
	SetCurrentImc(imc,TRUE);
#endif
	unsigned mode = conv_mode(imc);
	ImmSetConversionStatus(imc,CONV_MODE,IME_SMODE_PHRASEPREDICT);
	ImmSetCompositionStringW(imc,SCS_QUERYRECONVERTSTRING,extstr,WcLen(extstr)*2,NULL,0);
	DEBUGDO(CH_CANNA,DbgComp(imc,__func__));
	ImmSetCompositionStringW(imc,SCS_SETRECONVERTSTRING,extstr,WcLen(extstr)*2,NULL,0);
	DEBUGDO(CH_CANNA,DbgComp(imc,__func__));
	ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	DEBUGDO(CH_CANNA,DbgComp(imc,__func__));
	ImmSetConversionStatus(imc,mode,IME_SMODE_PHRASEPREDICT);//᤹
	ImmReleaseContext(cx->Win,imc);
	st = true;
    }
    return st;
}

/*
  CannaContext_t.FlagsϤ(Ѥ뤫)ǥХåѡ
  ׵ᡧtype6
	i16	true=set false=get
	i16	setΤȤƥֹ档getΤȤ̵롣
	u16	åȤե饰
  type9
	i16	ϤƥȤοåȤΤȤ0
	i32[]	{ƥֹ,cx->Flags} {p1}
*/
bool DumpContext(CanHeader* ch,int fd UNUSED)
{
    CannaContext_t* cx;
    int16_t do_set,cxn;
    uint16_t flags;
    Array dump;

    ArNew(&dump,sizeof(int32_t)*2,NULL); //int322
    Req6(ch,&do_set,&cxn,&flags);
    DEBUGLOG(CH_CANNA,"set/get %hd, context %hd, flags 0x%hx\n",do_set,cxn,flags);
    if(do_set){
	if((cx = ValidContext(cxn,__FUNCTION__)) != NULL){
	    cx->Flags = flags;
	}else{
	    DEBUGLOG(CH_CANNA,"invalid context number %hd\n",cxn);
	}
    }else{
	for(int n=0; n<ArUsing(&Context); ++n){
	    cx = ArElem(&Context,n);
	    if(cx->Win != NULL){
		int32_t* dp = ArExpand(&dump,1);
		*(dp++) = n;
		*dp = cx->Flags;
	    }
	}
    }
    bool st = Reply9(ch->Major,ch->Minor,ArUsing(&dump),ArAdr(&dump),ArUsing(&dump)*2);
    ArDelete(&dump);
    return st;
}

/*
  verbose٥channelꤹ롣
  ׵ᡧtype5
	i16	verbose level
	u16	(̤)
	i32	channel
  ʤ
 */
bool SetDebugChannel(CanHeader* ch,int fd UNUSED)
{
    int16_t lv;
    uint16_t dum;
    int32_t channel;
    Req5(ch,&lv,&dum,&channel);
    Verbose = lv;
    DebugChannel = channel;
    return true;
}

/*
  Խʸɽ롣
  tbl礭ϺATIMECOMPCOL_ITEMMAXĤʤФʤʤ
  ԤȤϥǥեȤͤ򥻥åȤ롣
  ׵ᡧtype2
	i16	ƥֹ
  type6
	i16	bool
	s8	ǡ(ATImeCol) sizeof(ATImeCol)*ATIMECOMPCOL_ITEMMAX Х
 */
bool GetColor(CanHeader* ch,int fd UNUSED)
{
    DEBUGLOG(CH_CANNA,"return default color with false.\n");
    /*
      ˼Ԥǥե(ʿطʿ)֤atokƤȤat.cδؿ֤롣
     */
    ATImeCol col[ATIMECOMPCOL_ITEMMAX];
    for(int index=0; index<ATIMECOMPCOL_ITEMMAX; ++index){
	col[index].Back=RGB(255,255,255); //
	col[index].Text=RGB(0,0,0); //
	col[index].UnderLine = true;
    }
    col[ATCOLINDEX_TARGETCONVERT].Back=RGB(0,0,0);
    col[ATCOLINDEX_TARGETCONVERT].Text=RGB(255,255,255);
    col[ATCOLINDEX_TARGETCONVERT].UnderLine = false;
    return Reply6(ch->Major,ch->Minor,false,(const char*)col,sizeof(col));
}

/*
  ImmGetCandidateWindow
  ׵ᡧtype2
	i16	ƥֹ
  type9
	i16	bool(ImmGetCandidateWindow)
	i32[0]	index
	i32[1]	type
	i32[2]	POINT.x
	i32[3]	POINT.y
	i32[4]	RECT.left
	i32[5]	RECT.top
	i32[6]	RECT.right
	i32[7]	RECT.bottom
 */
bool GetCandWin(CanHeader* ch,int fd UNUSED)
{
    HIMC imc;
    int32_t cf[8];
    bool st = false;
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	CANDIDATEFORM candform;
	st = ImmGetCandidateWindow(imc,0,&candform);
	cf[0] = candform.dwIndex;
	cf[1] = candform.dwStyle;
	cf[2] = candform.ptCurrentPos.x;
	cf[3] = candform.ptCurrentPos.y;
	cf[4] = candform.rcArea.left;
	cf[5] = candform.rcArea.top;
	cf[6] = candform.rcArea.right;
	cf[7] = candform.rcArea.bottom;
	ImmReleaseContext(cx->Win,imc);
	DEBUGLOG(CH_CANNA,"status %d\n",st);
    }
    return Reply9(ch->Major,ch->Minor,st,cf,ITEMS(cf));
}

/*
  θֹ֤
  ׵ᡧtype2
	i16	ƥֹ
  :type5
	i16	ֹ档顼-1
*/
bool CandIndex(CanHeader* ch,int fd UNUSED)
{
    bool st = false;
    HIMC imc;
    int16_t ans = -1;
    int16_t cxn = Req2(ch);
    CannaContext_t* cx = GetContext(cxn,&imc,__FUNCTION__);
    if(cx != NULL){
	int sz = ImmGetCandidateList(imc,0,NULL,0);
	if(sz != 0){
	    CANDIDATELIST* cl = malloc(sz);
	    ImmGetCandidateList(imc,0,cl,sz);
	    ans = cl->dwSelection;
	    free(cl);
	}
	st = Reply5(ch->Major,ch->Minor,ans);
    }
    return st;
}

//(C) 2008 thomas
