// -*- coding:euc-jp -*-
#define _GNU_SOURCE //memmem()
#include <string.h>
#include <stdbool.h>
#include <limits.h>
#include "list.h"

static inline bool is_nul(const Array* slist,int pos)
{
    return memcmp(ArElem(slist,pos),&(int){0},ArBlockSize(slist))==0;
}

static inline int nul_pos(const Array* slist,int start_pos)
{
    return ArFind(slist,start_pos,&(int){0});
}

//ꥹslist˥ꥹplistޤޤƤгϥ̵ֹ֤-1֤
int SubList(const Array* slist,const Array* plist)
{
    if(slist==NULL || plist==NULL)
	return -1;
    
    int slist_len = ArUsing(slist)-1;
    int plist_len = ArUsing(plist)-1;
    if(slist_len<=0 || plist_len<=0) //ɤ餫ʤ鼺ԤȤ롣
	return -1;
    
    int index = 0; //Фֹ
    int slist_pos = 0; //ФƬ
    bool found = false;
    while(slist_len >= plist_len){
	if(memcmp(ArElem(slist,slist_pos),plist->adr,plist_len*ArBlockSize(plist)) == 0){
	    found = true;
	    break;
	}
	int slist_new_pos = nul_pos(slist,slist_pos)+1; //̥ʸμ
	slist_len -= (slist_new_pos-slist_pos)/ArBlockSize(slist);
	slist_pos = slist_new_pos;
	++index;
    }
    return found ? index : -1;
}

//Фο֤
int ListCount(const Array* slist)
{
    if(slist==NULL || ArUsing(slist)==0)
	return 0;
    
    int mem=1;
    int pos=0;
    while(pos=nul_pos(slist,pos)+1, !is_nul(slist,pos)){
	++mem;
    }
    return mem;
}

//indexܤΥФΥɥ쥹֤
void* ListInc(const Array* slist,int index)
{
    if(slist==NULL || ArUsing(slist)==0 || index<0)
	return NULL;

    int pos=0;
    while(index > 0 && !is_nul(slist,pos)){
	pos = nul_pos(slist,pos)+1;
	--index;
    }
    return index>=0 && !is_nul(slist,pos) ? ArElem(slist,pos) : NULL;
}

/*
  start(>=0)ܤendܤΥФ롣
*/
Array* ListRemoveRange(Array* slist,int start,int end)
{
    int posb = ArIndex(slist,ListInc(slist,start));
    int pose = nul_pos(slist,ArIndex(slist,ListInc(slist,end)))+1;
    ArRemove(slist,posb,pose-posb);
    if(ArUsing(slist)==1){
	ArClear(slist); //ꥹȽλޡˤʤäꥢ롣
    }
    return slist;
}

/*
  memФǤֹ֤ФǤʤä-1֤
*/
int ListFind(const Array* slist,const Array* mem)
{
    Array cpmem;
    ArNew(&cpmem,ArBlockSize(mem),mem->constructor);
    ArCopy(&cpmem,mem);
    ArAdd1(&cpmem,&(int){0}); //ꥹȤˤ롣
    int index = SubList(slist,&cpmem);
    ArDelete(&cpmem);
    return index;
}

/*
  indexmem
  index<0ΤȤꥹȤκǸɲä
*/
Array* ListInsert(Array* slist,int index,const Array* mem)
{
    if(index >= 0){
	ArInsert(slist,
		 ArIndex(slist,ListInc(slist,index)),
		 ArUsing(mem),
		 ArAdrC(mem));
    }else{
	ArAdd1(ArAddAr(ArDec(slist)/*ꥹȤνλޡ*/,
		       mem), /*memդ­*/
	       &(int){0}); /*ꥹȤνλޡդ*/
    }
    return slist;
}

/*
  ꥹȤ롣memˤϥꥹȽλޡդƤȡ
  slistϽɲä롣
 */
Array* ListRaw(Array* slist,const void* mem)
{
    void* listend = memmem(mem,INT_MAX,&(int){0},2*ArBlockSize(slist));
    int listlen = (char*)listend+2*ArBlockSize(slist) - (char*)mem;
    return ArAddN(slist,mem,listlen/ArBlockSize(slist));
}

//(C) 2008 thomas
